/* synapp2.js - SynApp2 main interface
**
   +----------------------------------------------------------------------+
   | SynApp2 Version 1                                                    |
   +----------------------------------------------------------------------+
   | Copyright (c) 2007 - 2009 Richard Howell. All rights reserved.       |
   +----------------------------------------------------------------------+
   | This source file is subject to version 1.01 of the SynApp2 license,  |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.synapp2.org/license/1_01.txt                              |
   | If you did not receive a copy of the SynApp2 license and are unable  |
   | to obtain it through the world-wide-web, please send a note to       |
   | license@synapp2.org so we can mail you a copy immediately.           |
   +----------------------------------------------------------------------+
   | Authors: Richard Howell                                              |
   |                                                                      |
   +----------------------------------------------------------------------+
**
** http://www.synapp2.org
**
** $Id: synapp2.js,v 1.11 2009/05/01 20:47:19 richard Exp $
*/

//
// symbolic constants
//
var is_ie = navigator.userAgent.indexOf('MSIE ') > 0 ? true : false ;
var is_ie6 = navigator.userAgent.indexOf('MSIE 6') > 0 ? true : false ;
var is_safari = navigator.userAgent.indexOf('Safari') > 0 ? true : false ;
var force_var = 1; // set for actual deployment, 0 during development with Mozilla
var var_const = (force_var || is_ie) ? "var " : "const " ;

eval(var_const + "IS_MSIE       = is_ie;");
eval(var_const + "IS_MSIE6      = is_ie6;");
eval(var_const + "IS_SAFARI     = is_safari;");

eval(var_const + "_SHARED_      = '../_shared_/';");

eval(var_const + "ACTION_INIT   = 'init';");
eval(var_const + "ACTION_SELECT = 'select';");
eval(var_const + "ACTION_INSERT = 'insert';");
eval(var_const + "ACTION_UPDATE = 'update';");
eval(var_const + "ACTION_DELETE = 'delete';");

eval(var_const + "MODE_GET_NORM = 'get_norm';");
eval(var_const + "MODE_GET_INIT = 'get_init';");
eval(var_const + "MODE_GET_FLTR = 'get_fltr';");
eval(var_const + "MODE_PUT_NORM = 'put_norm';");
eval(var_const + "MODE_REPORT   = 'report';");
eval(var_const + "MODE_ADHOC    = 'adhoc';");
eval(var_const + "MODE_FETCH    = 'fetch';");
eval(var_const + "MODE_BATCH    = 'batch';");
eval(var_const + "MODE_CLOSE    = 'close';");
eval(var_const + "MODE_CANCEL   = 'cancel';");

////

var g_cxl = null;
var g_cxlref1b = null;

var g_appid = '';
var g_drag_adhoc = Array(); // [element] = drag_handler

////

// class cxl
//

// public:
//
// constructor
//
var cxl = function(pid, objective)
{
    this.init();
    this.set_page_id(pid);
    this.set_objective(objective);
    this.set_request_action(ACTION_SELECT);
};

cxl.prototype.init = function()
{
    this.m_container_id = '';
    this.m_iform_id = '';
    this.m_filter_map = Array();

    this.m_trigger_stat = false;

    this.m_feedback_id = '';
    this.m_feedback_fault_count = 0;

    this.m_request_action = '';
    this.m_request_mode = '';
    this.m_request_pid = '';
    this.m_request_objective = '';
    this.m_request_guidance = '';
    this.m_request_qid = '';
    this.m_request_pk = 0;
    this.m_request_limit_offset = 0;
    this.m_request_show_response = false;

    this.m_request_extra_args = '';
    this.m_request_pending = '';
    this.m_request_object = null;

    this.m_response_version = '';
    this.m_response_authentication = '';
    this.m_response_authorization = '';
    this.m_response_logout = '';
    this.m_response_object = null;
    this.m_response_rows = 0;
    this.m_response_cols = 0;
    this.m_response_firstpage = 1;
    this.m_response_lastpage = 1;
    this.m_response_remote = ''; // TODO: temporary, simple string; convert to standard payload
    this.m_response_feedback = Array();
    this.m_response_adhoc = null;
    this.m_response_goal_action = '';
    this.m_response_goal_container = '';
    this.m_response_goal_followup = '';
    this.m_response_goal_stat = '';
    this.m_response_axis = '';
    this.m_response_legends = '';

    this.m_response_offset = 0;
    this.m_response_limit = 0;
    this.m_response_insert_id = 0;
    this.m_response_insert_offset = 0;
    this.m_response_target_table = '';
    this.m_response_target_id = 0;
    this.m_response_affected_id = 0;
    this.m_response_found_rows = 0;

    this.m_remote = null;
    this.m_remote_container_id = null;
}

cxl.prototype.set_page_id = function(page_id)
{
    if (typeof page_id == "string")
    {
        this.m_request_pid = page_id;
    }
    else
    {
        this.m_request_pid = "";
    }
}

cxl.prototype.get_page_id = function()
{
    return this.m_request_pid;
}

cxl.prototype.set_objective = function(objective)
{
    if (typeof objective == "string")
    {
        this.m_request_objective = objective;
    }
    else
    {
        this.m_request_objective = "";
    }

    if (typeof g_search_guidance == "string")
    {
        this.m_request_guidance = g_search_guidance;
    }
    else
    {
        this.m_request_guidance = "";
    }
}

cxl.prototype.set_container = function(container_id)
{
    if (typeof container_id == "string")
    {
        this.m_container_id = container_id;
    }
    else
    {
        this.m_container_id = "";
    }
}

cxl.prototype.set_query_id = function(qid)
{
    if (typeof qid == "string")
    {
        this.m_request_qid = qid;
    }
    else
    {
        this.m_request_qid = "";
    }
}

cxl.prototype.set_request_action = function(action)
{
    if (typeof action == 'string' && action)
    {
        switch (action)
        {
        case ACTION_INIT:
        case ACTION_SELECT:
        case ACTION_INSERT:
        case ACTION_UPDATE:
        case ACTION_DELETE:
            this.m_request_action = action;
            break;
        default:
            break;
        }
    }
    else if (this.m_request_pending) // TODO: TBD: this block belongs elsewhere??
    {
        this.m_request_action = this.m_request_pending;
        this.m_request_pk = this.m_response_target_id;
        this.unset_pending();
    }
}

cxl.prototype.set_request_mode_report = function()
{
    this.m_request_mode = MODE_REPORT;
}

cxl.prototype.set_request_mode_adhoc = function()
{
    this.m_request_mode = MODE_ADHOC;
}

cxl.prototype.set_request_mode_fetch = function()
{
    this.m_request_mode = MODE_FETCH;
}

cxl.prototype.set_request_mode_batch = function()
{
    this.m_request_mode = MODE_BATCH;
}

cxl.prototype.set_request_mode_close = function()
{
    this.m_request_mode = MODE_CLOSE;
}

cxl.prototype.set_request_mode_cancel = function()
{
    this.m_request_mode = MODE_CANCEL;
}

cxl.prototype.request_mode_conditional_reset = function()
{
    if (this.m_request_mode == MODE_REPORT ||
        this.m_request_mode == MODE_ADHOC ||
        this.m_request_mode == MODE_FETCH ||
        this.m_request_mode == MODE_BATCH ||
        this.m_request_mode == MODE_CLOSE ||
        this.m_request_mode == MODE_CANCEL)
    {
        this.m_request_mode = '';
    }
}

cxl.prototype.append_request_extra_args = function(name, value)
{
    if (typeof name == 'string')
    {
        var arg_name = trim(name);

        if (arg_name.length)
        {
            this.m_request_extra_args += "&" + encodeURIComponent(arg_name);

            if (typeof value == 'string')
            {
                this.m_request_extra_args += "=" + encodeURIComponent(value);
            }
        }
    }
}

cxl.prototype.set_filter = function(tform_id, sform_id)
{
    if (typeof tform_id == 'string' && typeof sform_id == 'string')
    {
        var key = trim(tform_id);
        var val = trim(sform_id);

        if (key.length && val.length)
        {
            this.m_filter_map[key] = val;
        }
    }
}

cxl.prototype.get_filter = function(tform_id)
{
    return this.m_filter_map[tform_id] ? this.m_filter_map[tform_id] : '' ;
}

cxl.prototype.set_pending = function(action)
{
    this.m_request_pending = '';

    if (typeof action == 'string')
    {
        switch (action)
        {
        case ACTION_INSERT:
        case ACTION_UPDATE:
        case ACTION_DELETE:
            this.m_request_pending = action;
            break;
        default:
            break;
        }
    }
}

cxl.prototype.unset_pending = function()
{
    this.set_pending();
}

cxl.prototype.set_show_response = function(flag)
{
    this.m_request_show_response = flag ? true : false ;
}

////

cxl.prototype.nav_first = function(qid)
{
    this.m_request_limit_offset = 0;
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_dn = function(qid)
{
    this.m_request_limit_offset = this.m_response_offset + this.m_response_limit;
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_reload = function(qid)
{
    this.m_request_limit_offset = this.m_response_offset;
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_sync = function(qid)
{
    this.m_request_limit_offset = this.m_response_insert_offset;
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_up = function(qid)
{
    this.m_request_limit_offset = Math.max(0, this.m_response_offset - this.m_response_limit);
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_last = function(qid)
{
    this.m_request_limit_offset = Math.max(0, this.m_response_found_rows >= 1 ? this.m_response_found_rows - 1 : 0);
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_close = function(qid)
{
    this.unset_pending();
    this.set_request_mode_close();
    this.m_request_pk = 0;
    this.send_request(qid, ACTION_SELECT);
}

cxl.prototype.nav_select = function(qid)
{
    this.m_request_pk = this.get_pk();

    if (this.m_request_pk)
    {
        this.send_request(qid, ACTION_SELECT);
    }
}

cxl.prototype.add = function(qid)
{
    this.set_pending(ACTION_INSERT);
    this.send_request(qid, ACTION_INIT);
}

cxl.prototype.edit = function(qid)
{
    this.m_request_pk = this.get_pk();

    if (this.m_request_pk)
    {
        this.set_pending(ACTION_UPDATE);
        this.send_request(qid, ACTION_SELECT);
    }
}

// NOTE: IE7 - at least - does not like the identifier: delete
//
cxl.prototype._delete = function(qid)
{
    this.m_request_pk = this.get_pk();

    if (this.m_request_pk)
    {
        this.set_pending(ACTION_DELETE);
        this.send_request(qid, ACTION_SELECT);
    }
}

cxl.prototype.cancel = function(qid)
{
    this.unset_pending();
    this.set_request_mode_cancel();
    this.m_request_pk = 0;
    this.send_request(qid, ACTION_SELECT);
}

////

cxl.prototype.get_limit_offset = function()
{
    return this.m_request_limit_offset;
}

cxl.prototype.get_request_args = function(qid)
{
    var args = "";
    var independent_keys = null;

    if (this.m_request_mode == MODE_REPORT ||
        this.m_request_mode == MODE_ADHOC ||
        this.m_request_mode == MODE_FETCH ||
        this.m_request_mode == MODE_BATCH ||
        this.m_request_mode == MODE_CLOSE ||
        this.m_request_mode == MODE_CANCEL)
    {
        // do nothing
    }
    else
    {
        switch (this.m_request_action)
        {
        case ACTION_INSERT:
            independent_keys = get_independent_keys(this.m_container_id);
        case ACTION_UPDATE:
        case ACTION_DELETE:
            this.m_request_mode = MODE_PUT_NORM;
            break;
        case ACTION_INIT:
            independent_keys = get_independent_keys(this.m_container_id);
            this.m_request_mode = MODE_GET_INIT;
            this.m_request_action = ACTION_SELECT;
            break;
        case ACTION_SELECT:
        default:
            this.m_request_mode = MODE_GET_NORM;
            break;
        }
    }

    args += "_request_action_=" + this.m_request_action; // NOTE: first arg, no &
    args += "&_request_mode_=" + this.m_request_mode;
    args += "&_request_pid_=" +  this.get_page_id();
    args += "&_request_objective_=" + this.m_request_objective;
    args += "&_request_guidance_=" + this.m_request_guidance;

    if (typeof g_appid == 'string' && g_appid.length)
    {
        args += "&_request_appid_=" + g_appid;
    }

    var skip_qid_flag = false;

    if (typeof qid == 'string' && qid.length)
    {
        args += "&_request_qid_=" + qid;
        skip_qid_flag = true;

    }
    else if (this.m_request_qid)
    {
        args += "&_request_qid_=" + this.m_request_qid;
        skip_qid_flag = true;
    }

    if (this.m_request_pk)
    {
        args += "&_request_pk_=" + encodeURIComponent(this.m_request_pk);
    }
    else
    {
        args += "&_request_limit_offset_=" + this.get_limit_offset();
    }

    ////

    if (independent_keys && independent_keys.length)
    {
        for (var i = 0; i < independent_keys.length; i++)
        {
            var value = independent_keys[i];

            if (value)
            {
                args += ('&_request_keys_[]=' + encodeURIComponent(value));
            }
        }
    }

    ////

    if (this.m_request_show_response || typeof g_search_show_response == 'string')
    {
        args += "&_request_show_response_=true";
    }

    if (!this.m_iform_id)
    {
        var filter_form = this.get_filter(this.m_container_id);

        this.m_remote_container_id = filter_form ? this.m_container_id : null ; // TODO: HACK: KLUGE: pick up the tform

        args += get_container_args(filter_form, skip_qid_flag);

        args += this.get_input_value_args(filter_form);
    }
    else
    {
        this.m_feedback_id = this.m_iform_id + "_feedback"; // TODO: temporary
    }

    var args_id = this.m_iform_id ? this.m_iform_id : this.m_container_id ;

    args += get_container_args(args_id, skip_qid_flag);

    args += this.get_input_value_args(args_id);

    ////

    if (this.m_request_extra_args)
    {
        args += this.m_request_extra_args;
    }

    return args;
}

function get_container_args(id, skip_qid_flag)
{
    var args = "";

    if (m_map_id_args[id] && typeof m_map_id_args[id] == 'object')
    {
        for (var arg_name in m_map_id_args[id])
        {
            if (skip_qid_flag && arg_name == '_qid_')
            {
                continue;
            }

            var name = '_request' + arg_name;
            var value = m_map_id_args[id][arg_name];

            if (name)
            {
                args += ('&' + encodeURIComponent(name) + "=" + encodeURIComponent(value));
            }
        }
    }

    return args;
}

cxl.prototype.get_input_value_args = function(id)
{
    var args = "";

    if (typeof id == 'string' && id.length && this.m_request_mode != MODE_FETCH)
    {
        var container = document.getElementById(id);

        if (container)
        {
            var input_elements = container.getElementsByTagName("input");

            if (input_elements && input_elements.length)
            {
                for (var i = 0; i < input_elements.length; i++)
                {
                    var element = input_elements[i];

                    if (is_blind(element.id) || ((element.type == "radio" || element.type == "checkbox") && !element.checked))
                    {
                        continue;
                    }

                    var name = element.name;
                    var value = element.value;

                    if (name)
                    {
                        args += ('&' + encodeURIComponent(name) + "=" + encodeURIComponent(value));
                    }
                }
            }

            ////

            var select_elements = container.getElementsByTagName("select");

            if (select_elements && select_elements.length)
            {
                for (var i = 0; i < select_elements.length; i++)
                {
                    var select_element = select_elements[i];

                    var name = select_element.name;

                    if (name)
                    {
                        args += ('&_request_col_expand_[]=' + encodeURIComponent(name)); // drive select options list population

                        var selected_options = 0;

                        for (var j = 0; j < select_element.options.length; j++)
                        {
                            if (select_element.options[j].selected)
                            {
                                selected_options++;
                            }
                        }

                        if (selected_options)
                        {
                            for (var j = 0; j < select_element.options.length; j++)
                            {
                                var value = select_element.options[j].value;

                                if (select_element.options[j].selected)
                                {
                                    args += ('&' + encodeURIComponent(name + (selected_options > 1 ? '[]' : '')) + "=" + encodeURIComponent(value));
                                }
                            }
                        }
                    }
                }
            }

            ////

            var textarea_elements = container.getElementsByTagName("textarea");

            if (textarea_elements && textarea_elements.length)
            {
                for (var i = 0; i < textarea_elements.length; i++)
                {
                    var element = textarea_elements[i];

                    var name = element.name;
                    var value = element.value;

                    if (name)
                    {
                        args += ('&' + encodeURIComponent(name) + "=" + encodeURIComponent(value));
                    }
                }
            }
        }
    }

    return args;
}

function get_independent_keys(container_id)
{
    var independent_keys = Array();

    var nav_flags = find_container_nav_flags_by_id(container_id);

    if (nav_flags && nav_flags.contains('basis'))
    {
        var key_select_containers = find_key_select_containers();

        for (var i = 0; i < key_select_containers.length; i++)
        {
            var container_nav = get_container_nav(key_select_containers[i].id);

            if (container_nav)
            {
                var selected_keys = get_selected_keys(key_select_containers[i]);

                if (selected_keys && selected_keys.length)
                {
                    for (var j = 0; j < selected_keys.length; j++)
                    {
                        var pk = selected_keys[j];
                        independent_keys.push(container_nav + ',' + pk);
                    }
                }
            }
        }
    }

    return independent_keys;
}

////

cxl.prototype.send_request = function(qid, action)
{
    this.set_request_action(action);

    var args = this.get_request_args(qid);

    if (this.m_request_object == null)
    {
        this.create_request_object();
    }

    if (this.m_request_object != null)
    {
        this.m_request_object.open("POST", _SHARED_ + "action.php", true);
        this.m_request_object.onreadystatechange = this.create_handler_onreadystatechange(this);
        this.m_request_object.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        this.m_request_object.send(args); // args must be encodeURI()
    }
    else
    {
        // error
    }
}

cxl.prototype.create_request_object = function()
{
    try
    {
        this.m_request_object = new XMLHttpRequest();
    }
    catch (e1)
    {
        try
        {
            this.m_request_object = new ActiveXObject("Msxml2.XMLHTTP");
        }
        catch (e2)
        {
            try
            {
                this.m_request_object = new ActiveXObject("Microsoft.XMLHTTP");
            }
            catch (e3)
            {
                this.m_request_object = null;
            }
        }
    }
}

cxl.prototype.response_handler = function()
{
    if (this.m_request_object.readyState == 4)
    {
        if (this.m_request_object.status == 200)
        {
            this.manage_debug_msg();

            this.m_feedback_fault_count = this.characterize_response(this.m_request_object.responseXML);

            this.manage_version();
            this.manage_auth_msg();

            if (this.m_response_authentication != 'succeeded' ||
                this.m_response_authorization != 'succeeded' ||
                this.m_response_logout != '')
            {
                ; // do nothing
            }
            else if (this.m_feedback_fault_count)
            {
                this.process_feedback();
            }
            else if (this.m_response_remote)
            {
                if (this.m_remote)
                {
                    this.m_remote.process();
                }
            }
            else if (this.m_response_goal_action)
            {
                this.goal_action();
            }
            else if (this.m_response_adhoc)
            {
                this.process_adhoc();
            }
            else
            {
                this.update_container(this.m_container_id);
            }
        }
        else
        {
            debug_msg("Request status: " + this.m_request_object.status + "\n" +
                                           this.m_request_object.responseText); // 404 = request url not found, 500 = error
        }
    }
}

cxl.prototype.create_handler_onreadystatechange = function(obj)
{
    return function() { obj.response_handler() }
}

cxl.prototype.remote_accept = function(parent_container, end_func)
{
    this.m_remote = new remote(this);
    this.m_remote.accept(parent_container, end_func);
}

cxl.prototype.do_remote_followup = function(insert_offset)
{
    var followupid = 'id__tform__orders'; // TODO: TEMP: DEBUG: // tform
alert('DEBUG:' + followupid);
    this.m_response_goal_followup = '';
    this.m_trigger_stat = true;
    this.m_request_limit_offset = insert_offset;
    do_exchange(followupid);  // TODO: HACK:
}

////

cxl.prototype.response_has_debug_msg = function()
{
    var result = false;

    if (this.m_request_object.responseXML && this.m_request_object.responseXML.nodeType == 9)
    {
        var debug_msg_elements = this.m_request_object.responseXML.getElementsByTagName("debug_msg");

        if (debug_msg_elements && debug_msg_elements.length)
        {
            result = true;
        }
    }

    return result;
}

cxl.prototype.response_has_error_msg = function()
{
    var result = false;

    if (this.m_request_object.responseXML && this.m_request_object.responseXML.nodeType == 9)
    {
        var error_elements = this.m_request_object.responseXML.getElementsByTagName("error");

        if (error_elements &&
            error_elements.length &&
            error_elements[0].firstChild &&
            error_elements[0].firstChild.nodeValue)
        {
            result = true;
        }
    }

    return result;
}

cxl.prototype.manage_version = function()
{
    var version_container = document.getElementById('id_version');

    if (version_container)
    {
        version_container.innerHTML = 'version ' + this.m_response_version;
    }
}

cxl.prototype.manage_debug_msg = function()
{
    var error_flag = this.response_has_error_msg();

    if (error_flag ||
        this.m_request_show_response ||
        this.response_has_debug_msg() ||
        this.m_request_object.responseText == "")
    {
        debug_msg(this.m_request_object.responseText, error_flag);
    }
}

cxl.prototype.manage_auth_msg = function()
{
    if (this.get_page_id() == 'login')
    {
        if (this.m_response_authentication == 'succeeded')
        {
            window.location = document.referrer; // Login success
        }
        else
        {
            set_container_msg_markup('Unrecognized username and/or password');
        }
    }
    else if (this.get_page_id() == 'logout')
    {
        if (this.m_response_logout)
        {
            window.location = '../' + this.m_response_logout + '/';
        }
    }
    else if (this.m_response_authentication != 'succeeded')
    {
        set_container_msg_markup('Please <a id="id_login_" href="' + _SHARED_ + 'login.htm?appid=' + g_appid + '">Login</a>.');
        set_focus('id_login_');
    }
    else if (this.m_response_authorization != 'succeeded')
    {
        set_container_msg_markup('You are not authorized to use this page.');
    }
    else
    {
        var attrs = get_page_mark_attrs();

        if (attrs)
        {
            var breadcrumb_msg = 'Jump to: ' + attrs.app + ', page ' + attrs.title;
            set_container_msg_markup('<a id="id_crumb_" href="' + attrs.url + '">' + breadcrumb_msg + '</a>');
        }
    }
}

////

cxl.prototype.characterize_response = function(node)
{
    this.m_response_version = '';
    this.m_response_authentication = '';
    this.m_response_authorization = '';
    this.m_response_logout = '';
    this.m_response_rows = 0;
    this.m_response_cols = 0;
    this.m_response_firstpage = 1;
    this.m_response_lastpage = 1;
    this.m_response_offset = 0;
    this.m_response_limit = 0;
    this.m_response_insert_id = 0;
    this.m_response_insert_offset = 0;
    this.m_response_target_id = 0;
    this.m_response_affected_id = 0;
    this.m_response_remote = '';
    this.m_response_feedback = Array();
    this.m_response_adhoc = null;
    this.m_response_goal_action = '';
    this.m_response_goal_container = '';
    this.m_response_goal_followup = '';
    this.m_response_goal_stat = '';
    this.m_response_axis = '';
    this.m_response_legends = '';

    this.reset_feedback();

    if (node && node.nodeType == 9)
    {
        this.wick_response_members(node);

        ////

        var status_elements = node.getElementsByTagName("status");

        if (status_elements && status_elements.length)
        {
            for (var i = 0; i < status_elements.length; i++)
            {
                var status_node = status_elements[i].firstChild;

                if (status_node && status_node.nodeType == 3)
                {
                    this.m_response_feedback.push({name:status_elements[i].getAttribute('name'), value:status_node.nodeValue});
                }
            }
        }

        ////

        var auth_actions_nodes = node.getElementsByTagName("auth_actions");

        if (auth_actions_nodes && auth_actions_nodes.length)
        {
            var auth_action_element = auth_actions_nodes[0];

            if (auth_action_element && auth_action_element.hasChildNodes())
            {
                var response_auth_actions = Array();

                for (var i = 0; i < auth_action_element.childNodes.length; i++)
                {
                    var action_node = auth_action_element.childNodes[i];

                    if (action_node.nodeType == 1)
                    {
                        var action_qid = action_node.getAttribute('id');

                        if (action_qid)
                        {
                            if (action_node.firstChild)
                            {
                                response_auth_actions[action_qid] = action_node.firstChild.nodeValue.split(',');
                            }
                            else
                            {
                                response_auth_actions[action_qid] = Array();
                            }
                        }
                    }
                }

                manage_auth_action_controls(response_auth_actions);
            }
        }

        ////

        var adhoc_elements = node.getElementsByTagName("adhoc");

        if (adhoc_elements && adhoc_elements.length)
        {
            this.m_response_adhoc = true;
        }
    }

    return this.m_response_feedback.length; // NOTE: fault_count
}

cxl.prototype.wick_response_members = function(node, member_name)
{
    if (node.nodeType == 3) // TEXT_NODE
    {
        if (typeof member_name == "string")
        {
            if (typeof this[member_name] == "number")
            {
                this[member_name] = parseInt(node.nodeValue);
            }
            else if (typeof this[member_name] == "string")
            {
                this[member_name] = trim(node.nodeValue);
            }
        }
    }
    else
    {
        var member = null;

        if (node.nodeType == 1) // ELEMENT_NODE
        {
            member = "m_response_" + node.nodeName;
        }

        if (node.hasChildNodes())
        {
            for (var i = 0; i < node.childNodes.length; i++)
            {
                this.wick_response_members(node.childNodes[i], member);
            }
        }
    }
}

cxl.prototype.process_feedback = function()
{
    if (this.m_response_feedback && this.m_response_feedback.length)
    {
        if (this.m_response_feedback[0].value.indexOf('delete_denied') >= 0)
        {
            var msg = this.m_response_feedback[0].name + "\n\n";

            for (var i = 0; i < this.m_response_feedback.length; i++)
            {
                msg += this.m_response_feedback[i].value + "\n";
            }

            alert(msg);
        }
        else
        {
            var feedback_container = document.getElementById(this.m_feedback_id);

            if (feedback_container)
            {
                var feedback_label_elements = feedback_container.getElementsByTagName('label');

                if (feedback_label_elements && feedback_label_elements.length)
                {
                    // process each fault
                    //
                    for (var i = 0; i < this.m_response_feedback.length; i++)
                    {
                        // match fault with feedback_label by name
                        //
                        for (var j = 0; j < feedback_label_elements.length; j++)
                        {
                            var for_id = feedback_label_elements[j].getAttribute('for');

                            if (!for_id && feedback_label_elements[j].attributes['for'])
                            {
                                for_id = feedback_label_elements[j].attributes['for'].value; // HACK: IE
                            }

                            if (for_id && for_id.endsWith(this.m_response_feedback[i].name))
                            {
                                // report the fault
                                //
                                feedback_label_elements[j].innerHTML = this.m_response_feedback[i].value;
                                feedback_label_elements[j].style.display = "block";

                                break;
                            }
                        }
                    }
                }
            }
        }
    }
}

cxl.prototype.process_adhoc = function()
{
    if (this.m_response_adhoc)
    {
        var node = this.m_request_object.responseXML;

        if (node && node.nodeType == 9)
        {
            var adhoc_elements = node.getElementsByTagName("adhoc");

            if (adhoc_elements && adhoc_elements.length > 0)
            {
                var container_node = document.getElementById(this.m_container_id);

                if (container_node)
                {
                    var s1 = this.m_request_object.responseText.indexOf("<adhoc>");
                    var s2 = this.m_request_object.responseText.indexOf("</adhoc>");

                    if (s1 > 0 && s2 > s1)
                    {
                        container_node.innerHTML = this.m_request_object.responseText.substring(s1 + 7, s2); // 7 is length of "<adhoc>"
                    }

                    ////

                    var s3 = this.m_request_object.responseText.indexOf("<idd>");
                    var s4 = this.m_request_object.responseText.indexOf("</idd>");

                    if (s3 > 0 && s4 > s3)
                    {
                        var idd = this.m_request_object.responseText.substring(s3 + 5, s4); // 5 is length of "<idd>"
                        var idds = idd.split(",");

                        for (var iddi = 0; iddi < idds.length; iddi++)
                        {
                            if (IS_SAFARI) break; // TODO: BUG: HACK: drag handler breaks Safari select options

                            var id = idds[iddi];
                            g_drag_adhoc[id] = DragHandler.attach(document.getElementById(id));
                        }
                    }
                }
            }
        }
    }
}

cxl.prototype.goal_action = function()
{
    if (this.m_response_goal_action)
    {
        var container_id = find_container_id_by_role(this.m_response_goal_container);
        var stat_id = find_container_id_by_role(this.m_response_goal_stat);
        var followup_id = find_container_id_by_role(this.m_response_goal_followup);

        ////

        this.update_container(container_id);

        ////

        if (this.m_request_pending == ACTION_INSERT)
        {
            lookup_all(container_id);
        }

        if (this.m_request_mode != MODE_FETCH)
        {
            this.update_stats(stat_id);
        }

        ////

        xshow(this.m_response_goal_action);

        ////

        if (this.m_request_mode != MODE_FETCH)
        {
            this.m_trigger_stat = false;
            stat_all(this.get_page_id(), this.m_request_objective, stat_id);
        }

        ////

        this.m_response_goal_action = '';
        this.m_response_goal_stat = '';
        this.m_response_goal_followup = '';
    }

    ////

    this.set_request_action(ACTION_SELECT);
    this.m_request_mode = '';
    this.m_request_pk = 0;

    ////

    if (followup_id)
    {
        this.m_trigger_stat = true;
        this.m_request_limit_offset = this.m_response_insert_offset;

        if (this.m_request_guidance)
        {
            do_exchange1b(followup_id);  // TODO: HACK:
        }
        else
        {
            do_exchange(followup_id);  // TODO: HACK:
        }
    }
}

/*
cxl.prototype.display_standalone = function(container_id, is_standalone) // TODO: TBD: make names/tags to refer to fk_fwd??
{
    var container = document.getElementById(container_id);

    if (container)
    {
        var div_elements = container.getElementsByTagName("div");

        if (div_elements && div_elements.length)
        {
            for (var i = 0; i < div_elements.length; i++)
            {
                var element = div_elements[i];

                if (element)
                {
                    var id = element.getAttribute("id");
                    var name = element.getAttribute("name")

                    if (id && name && name == "form_standalone") // TODO: define constant
                    {
                        hide_show(id, is_standalone ? 'show' : 'hide');
                    }
                }
            }
        }
    }
}
*/

cxl.prototype.update_stats = function(container_id)
{
    if (container_id)
    {
        var xmgr = new csx(container_id);

        xmgr.set_cell_by_row_name(0, 'found_rows', this.m_response_found_rows);
    }
}

function resize_container(container_id, row_size)
{
    var container = document.getElementById(container_id);

    if (container && row_size > 0)
    {
        var nodeName = container.nodeName.toLowerCase();

        var table_elements = nodeName == "tbody" ? Array(container) : container.getElementsByTagName("tbody");

        if (table_elements && table_elements.length)
        {
            var table_element = table_elements[0];

            if (table_element)
            {
                var rows = table_element.rows;

                if (rows && rows.length && rows.length != row_size)
                {
                    clr_select_state_all(container_id, true); // release any existing node association(s)

                    ////

                    var parent_class = (table_element.parentNode && table_element.parentNode.className) ? table_element.parentNode.className + '_' : '' ;
                    var bcg_even_row = find_css_element(parent_class + 'bcg_even_row', 'backgroundColor'); // 'bcg_even_row' suffix is magic

                    ////

                    if (rows.length < row_size)
                    {
                        while (rows.length < row_size)
                        {
                            var row_element = table_element.insertRow(rows.length);

                            for (var i = 0; i < rows[0].cells.length; i++)
                            {
                                var c = row_element.insertCell(row_element.cells.length);

                                if (rows[0].cells[i].style.display)
                                {
                                    c.style.display = rows[0].cells[i].style.display; // TODO: HACK: KLUGE: offset / hidden
                                }
                            }

                            ////

                            if (bcg_even_row && !(rows.length % 2))
                            {
                                row_element.style.backgroundColor = bcg_even_row;
                            }
                        }
                    }
                    else
                    {
                        while (rows.length > row_size)
                        {
                            table_element.deleteRow(rows.length - 1);
                        }
                    }
                }
            }
        }
    }
}

cxl.prototype.update_container = function(container_id)
{
    var node = this.m_request_object.responseXML;

    if (!node || node.nodeType != 9)
    {
        return;
    }

    ////

    if (this.m_request_mode != MODE_FETCH)
    {
        form_reset(container_id);
        clr_select_state_all(container_id);
    }

    ////

    resize_container(container_id, this.m_response_rows); // TODO: TBD: test this.m_request_mode != MODE_FETCH??

    ////

    var container = document.getElementById(container_id);

    if (container)
    {
        var response_select_nodes = node.getElementsByTagName('select');

        var nav_flags = {lastpage:this.m_response_lastpage, firstpage:this.m_response_firstpage};

        manage_nav_controls(container, nav_flags);

        ////

        if (this.m_request_mode != MODE_FETCH)
        {
            update_expanded_elements(response_select_nodes, container.getElementsByTagName('select'));
        }

        ////

        var xmgr = new csx(container_id);

        ////

        var map_col_name = this.m_response_axis.split(","); // NOTE: must match response_cols exactly

        var rows = node.getElementsByTagName("tr");

        for (var r = 0; rows && r < rows.length && r < xmgr.get_row_count(); r++)
        {
            var pk = rows[r].getAttribute('id');

            if (pk)
            {
                xmgr.set_pk(r, parseInt(pk));
            }

            var response_cols = rows[r].getElementsByTagName("td");

            var assigned = Array();
            var unassigned = Array();

            for (var j = 0; response_cols && j < response_cols.length; j++)
            {
                var name = map_col_name[j];
                var value = response_cols[j].firstChild ? response_cols[j].firstChild.nodeValue : '' ;

                var c = xmgr.set_cell_by_row_name(r, name, value);

                if (c != null)
                {
                    assigned[c] = true;
                }
                else
                {
                    unassigned.push(j);
                }
            }

            ////

            if (this.m_request_mode != MODE_FETCH &&
                this.m_request_mode != MODE_GET_INIT &&
                assigned.length < xmgr.get_col_count())
            {
                for (var c = 0; c < xmgr.get_col_count() && unassigned.length > 0; c++)
                {
                    if (!assigned[c])
                    {
                        var j = unassigned.shift();
                        var value = response_cols[j].firstChild ? response_cols[j].firstChild.nodeValue : '' ;
                        var result = xmgr.set_cell_by_row_col(r, c, value);
                    }
                }
            }
        }

        ////

        for (; r < xmgr.get_row_count(); r++)
        {
            xmgr.set_pk(r, '');

            for (var c = 0; c < xmgr.get_col_count(); c++)
            {
                xmgr.set_cell_by_row_col(r, c, '');
            }
        }

        ////

        if (this.m_request_mode != MODE_FETCH)
        {
            update_expanded_elements(response_select_nodes, container.getElementsByTagName('input'));
        }
    }
}

function update_expanded_elements(response_select_nodes, elements)
{
    if (response_select_nodes && response_select_nodes.length && elements && elements.length)
    {
        // process response "select" nodes
        //
        for (var s = 0; s < response_select_nodes.length; s++)
        {
            var response_select_node = response_select_nodes[s];

            if (response_select_node)
            {
                // match response and container nodes by name
                //
                var response_select_name = response_select_node.getAttribute('name');

                if (response_select_name)
                {
                    // fetch matching container "select" node
                    //
                    var update_element = get_named_element(elements, response_select_name);

                    if (update_element)
                    {
                        // discard any existing container options
                        //
                        remove_select_options(update_element);

                        // fetch response options
                        //
                        var response_options = response_select_node.getElementsByTagName("option");

                        if (response_options && response_options.length)
                        {
                            // process response options
                            //
                            for (var i = 0; i < response_options.length; i++)
                            {
                                var option_node = response_options[i].firstChild;

                                if (option_node && option_node.nodeType == 3)
                                {
                                    var value = response_options[i].getAttribute('value');
                                    var text = option_node.nodeValue;

                                    // update container
                                    //
                                    append_select_option(update_element, value, text);
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

cxl.prototype.reset_feedback = function()
{
    var feedback_container = document.getElementById(this.m_feedback_id);

    if (feedback_container)
    {
        var feedback_label_elements = feedback_container.getElementsByTagName("label")

        if (feedback_label_elements && feedback_label_elements.length)
        {
            for (var j = 0; j < feedback_label_elements.length; j++)
            {
                feedback_label_elements[j].style.display = "none";
            }
        }
    }
}

//// TODO: utility functions - move and generalize

function get_named_element(elements, name)
{
    var named_element = null;

    if (elements && elements.length && name)
    {
        // TODO: this could be a map instead of a search loop

        for (var i = 0; i < elements.length; i++)
        {
            var element = elements[i];

            if (element && element.getAttribute && element.getAttribute('name') == name)
            {
                named_element = element;
                break;
            }
        }
    }

    return named_element;
}

function remove_select_options(select_element)
{
    if (select_element)
    {
        var container_options = select_element.getElementsByTagName("option");

        if (container_options && select_element.remove)
        {
            // process back to front to avoid pulling the rug out from under our feet
            //
            for (var i = container_options.length - 1; i >= 0; i--)
            {
                select_element.remove(i);
            }
        }
    }
}

function append_select_option(element, value, text)
{
    if (element)
    {
        var nodeName = element.nodeName.toLowerCase();

        if (nodeName == 'select')
        {
            var option = document.createElement('option');

            option.value = value;
            option.text = text;

            try
            {
                element.add(option, null); // standards compliant; doesn't work in IE
            }
            catch(ex)
            {
                element.add(option); // IE only
            }
        }
        else if (nodeName == 'input')
        {
            element.value = text;
        }
    }
}

/*
function set_select_option(id_select, value)
{
    var element = document.getElementById(id_select);

    if (element && element.nodeName.toLowerCase() == 'select')
    {
        var first_selected = -1;

        for (var i = 0; i < element.options.length; i++)
        {
            if (element.options[i].value == value)
            {
                if (first_selected < 0)
                {
                    first_selected = i;
                }

                element.options[i].selected = true;
            }
            else
            {
                element.options[i].selected = false;
            }
        }

        element.selectedIndex = first_selected;
    }
}
*/

////

cxl.prototype.get_pk = function()
{
    var result = null;

    var container = document.getElementById(this.m_container_id);

    if (container)
    {
        var nodeName = container.nodeName.toLowerCase();

        var table_elements = nodeName == "tbody" ? Array(container) : container.getElementsByTagName("tbody");

        if (table_elements && table_elements.length)
        {
            var row_elements = table_elements[0].getElementsByTagName("tr");

            if (row_elements)
            {
                for (var r = 0; r < row_elements.length; r++)
                {
                    if (get_select_state(this.m_container_id, r, row_elements[r]))
                    {
                        var row_cells = row_elements[r].getElementsByTagName("td");

                        if (row_cells && row_cells.length && row_cells[0].innerHTML)
                        {
                            result = row_cells[0].innerHTML;  // TODO: HACK: KLUGE: ASSUME: cell[0] is pk value
                        }
                        else
                        {
                            // TODO: error msg??
                        }
                        break;
                    }
                }
            }
        }
    }

    return result;
}

function get_selected_keys(container)
{
    var result = Array();

    if (container && container.id)
    {
        var nodeName = container.nodeName.toLowerCase();

        var table_elements = nodeName == "tbody" ? Array(container) : container.getElementsByTagName("tbody");

        if (table_elements && table_elements.length)
        {
            var row_elements = table_elements[0].getElementsByTagName("tr");

            if (row_elements)
            {
                for (var r = 0; r < row_elements.length; r++)
                {
                    if (get_select_state(container.id, r, row_elements[r]))
                    {
                        var row_cells = row_elements[r].getElementsByTagName("td");

                        if (row_cells && row_cells.length && row_cells[0].innerHTML)
                        {
                            result.push(row_cells[0].innerHTML); // TODO: HACK: KLUGE: ASSUME: cell[0] is pk value
                        }
                    }
                }
            }
        }
    }

    return result;
}

////

// class csx
//

// public:
//
// constructor
//
var csx = function(id)
{
    this.init();
    this.m_container_id = id;

    this.build();
};

csx.prototype.init = function()
{
    this.m_container_id = null;
    this.m_id_offset = 0;
    this.m_cells = null;
    this.m_row_count = 0;
    this.m_col_count = 0;
    this.m_map_name_col = Array();
}

csx.prototype.build = function()
{
    this.fetch_cells();
    this.fetch_maps();
}

csx.prototype.fetch_cells = function()
{
    this.m_id_offset = 0;
    this.m_cells = null;
    this.m_row_count = 0;
    this.m_col_count = 0;

    var row_count = 0;
    var id_offset = 0;

    ////

    var container = document.getElementById(this.m_container_id);

    if (container)
    {
        var nodeName = container.nodeName.toLowerCase();

        ////

        if (nodeName == 'input' || nodeName == 'textarea')
        {
            this.m_cells = Array(container); // NOTE: supports lookup/fetch
            row_count = 1;
        }

        ////

        if (!this.m_cells)
        {
            var table_elements = nodeName == "tbody" ? Array(container) : container.getElementsByTagName("tbody");

            if (table_elements && table_elements.length)
            {
                var row_elements = table_elements[0].getElementsByTagName("tr");

                if (row_elements)
                {
                    this.m_cells = table_elements[0].getElementsByTagName("td");

                    if (this.m_cells)
                    {
                        row_count = row_elements.length;
                        id_offset = 1; // TODO: actually check for hidden element(s) // ASSUME: 1 hidden element for 'id'

                        for (var r = 0; r < row_elements.length; r++)
                        {
                            if (!row_elements[r].onclick)
                            {
                                row_elements[r].onclick = create_select_handler(this.m_container_id, row_elements, r);
                            }
                        }
                    }
                }
            }
        }

        ////

        if (!this.m_cells)
        {
            var forms = nodeName == "form" ? Array(container) : container.getElementsByTagName('form');

            if (forms && forms.length)
            {
                this.m_cells = forms[0].elements;

                if (this.m_cells)
                {
                    row_count = 1;
                }
            }
        }

        ////

        if (this.m_cells)
        {
            var cell_count = this.m_cells.length;

            if (row_count && cell_count && (cell_count % row_count == 0))
            {
                this.m_row_count = row_count;
                this.m_col_count = cell_count / row_count;
                this.m_id_offset = id_offset;
            }
            else
            {
                // TODO: error msg - irregular
                this.m_cells = null;
            }
        }

        if (this.m_cells)
        {
            var thead_elements = container.getElementsByTagName("thead");

            if (thead_elements && thead_elements.length)
            {
                var row_elements = thead_elements[0].getElementsByTagName("tr");

                if (row_elements && row_elements.length && row_elements[0].cells && row_elements[0].cells.length)
                {
                    for (var c = 0; c < row_elements[0].cells.length; c++)
                    {
                        var cell = this.get_cell(0, c);

                        if (cell && !row_elements[0].cells[c].onclick)
                        {
                            row_elements[0].cells[c].onclick = create_order_handler(this.m_container_id, cell.getAttribute("axis"), row_elements[0], c);
                        }
                    }
                }
            }
        }
    }
}

csx.prototype.get_row_count = function()
{
    return this.m_row_count;
}

csx.prototype.get_col_count = function()
{
    return this.m_col_count - this.m_id_offset;
}

csx.prototype.get_cell = function(r, c)
{
    var cell = null;

    if (r >= 0 && r < this.get_row_count() && c >= 0 && c < this.get_col_count())
    {
        var i = r * this.m_col_count + c + this.m_id_offset;

        if (i < this.m_cells.length)
        {
            cell = this.m_cells[i];
        }
    }

    return cell;
}

csx.prototype.set_cell_value = function(cell, value)
{
    var result = null;

    if (cell && typeof cell.nodeName == 'string')
    {
        switch (cell.nodeName.toLowerCase())
        {
        case "td":
            cell.innerHTML = (typeof value == 'number' || value.length) ? value : '&nbsp;' ;
            result = true;
            break;
        case "select":
            cell.value = value ? value : 1 ; // TODO: KLUGE: verify that value is valid else select first option
            result = true;
            break;
        case "input":
            if (cell.type != 'text')
            {
                break;
            }
        case "textarea":
        default:
            cell.value = value;
            result = true;
            break;
        }
    }

    return result;
}

csx.prototype.set_pk = function(r, value)
{
    if (r >= 0 && r < this.get_row_count() && this.m_col_count > 0)
    {
        var i = r * this.m_col_count;

        if (i < this.m_cells.length &&
            this.m_cells[i].nodeName.toLowerCase() == 'td') // TODO: HACK: KLUGE: filter 'td' nodeName to keep from clobbering 'form' data
        {
            this.set_cell_value(this.m_cells[i], value);
        }
    }
}

csx.prototype.set_cell_by_row_col = function(r, c, value)
{
    return this.set_cell_value(this.get_cell(r, c), value) ? c : null ;
}

csx.prototype.set_cell_by_row_name = function(r, name, value)
{
    var result = null;

    if (name && typeof this.m_map_name_col[name] == 'number')
    {
        result = this.set_cell_by_row_col(r, this.m_map_name_col[name], value);
    }

    return result;
}

csx.prototype.fetch_maps = function()
{
    this.m_map_name_col = Array();

    for (var c = 0; c < this.get_col_count(); c++)
    {
        var cell = this.get_cell(0, c);

        if (cell)
        {
            var col_name = null;

            if ((col_name = cell.getAttribute('name')) ||
                (col_name = cell.getAttribute('axis')))
            {
                this.m_map_name_col[col_name] = c;
            }
        }
    }
}

////

//
// misc helpers
//

function get_page_id()
{
    var pid = '';

    var cxlref = get_cxlref(0);

    if (cxlref)
    {
        pid = cxlref.get_page_id();
    }

    return pid;
}

function do_lookup(control, container_id, qid, pk)
{
    var lookup_request = new cxl(get_page_id());

    if (control && control.options && control.options.length)
    {
        if (control.selectedIndex < 0 || control.selectedIndex >= control.options.length)
        {
            control.selectedIndex = 0; // TODO: HACK: this block shouldn't be necessary
        }

        lookup_request.set_container(container_id);
//        lookup_request.set_show_response(true);
        lookup_request.m_request_pk = control.options[control.selectedIndex].value; // TODO: HACK: KLUGE: need better method to manage m_request_pk
        lookup_request.set_request_mode_fetch();
        lookup_request.send_request(qid);
    }
    else
    {
        lookup_request.set_container(container_id);
//        lookup_request.set_show_response(true);
        lookup_request.m_request_pk = (typeof pk != 'undefined' ? pk : 0);
        lookup_request.set_request_mode_fetch();
        lookup_request.send_request(qid);
    }
}

function do_stat(pid, objective, qid, container_id)
{
    if (pid && objective && qid && container_id)
    {
        var stat_request = new cxl(pid, objective);

        stat_request.set_container(container_id);
//        stat_request.set_show_response(true);
        stat_request.set_request_mode_fetch();
        stat_request.send_request(qid);
    }
}

function create_select_handler(container_id, rows, r)
{
    clr_select_state(container_id, r, rows[r], true); // release any existing node association(s)

    return function()
    {
        clr_select_state_all(container_id); // enforces single row selection behavior
        set_select_state(container_id, r, rows[r]);
    }
}

function create_order_handler(container_id, axis, row, c)
{
    return function()
    {
        set_order(container_id, axis, row, c);
    }
}

function drag_init()
{
    var div_elements = document.getElementsByTagName("div");

    if (div_elements && div_elements.length)
    {
        for (var i = 0; i < div_elements.length; i++)
        {
            var element = div_elements[i];

            if (element)
            {
                var id = element.getAttribute("id");

                if (id && id.indexOf("id__group__") == 0) // TODO: KLUGE: HACK:
                {
                    g_drag_adhoc[id] = DragHandler.attach(element);
                }
            }
        }
    }
}

////

function reg_blind(id)
{
    if (id)
    {
        m_map_id_is_blind[id] = {_is_blind_:true};
    }
}

function is_blind(id)
{
    return m_map_id_is_blind[id] && typeof m_map_id_is_blind[id]._is_blind_ == 'boolean' ? m_map_id_is_blind[id]._is_blind_ : false ;
}

function reg_args(container_id, args)
{
    if (container_id)
    {
        m_map_id_args[container_id] = args;
    }
}

function reg_date(container_id, datepicker_format)
{
    if (container_id && typeof setAttributeEx == 'function')
    {
        setAttributeEx(container_id, 'datepicker', 'true');

        if (datepicker_format)
        {
            setAttributeEx(container_id, 'datepicker_format', datepicker_format);
        }
    }
}

function get_container_qid(id)
{
    return m_map_id_args[id] && typeof m_map_id_args[id]._qid_ == 'string' ? m_map_id_args[id]._qid_ : null ;
}

function get_container_nav(id)
{
    return m_map_id_args[id] && typeof m_map_id_args[id]._nav_ == 'string' ? m_map_id_args[id]._nav_ : 0 ; // default value of 0 supports simple forms with no '_nav_' var
}

function get_container_order(id)
{
    return m_map_id_args[id] && typeof m_map_id_args[id]._order_ == 'string' ? m_map_id_args[id]._order_ : null ;
}

function set_container_order(id, value)
{
    if (m_map_id_args[id] && typeof m_map_id_args[id]._order_ == 'string' && typeof value == 'string')
    {
        m_map_id_args[id]._order_ = value;
    }
}

////

function set_order(container_id, axis, row, c)
{
    var order_value = get_container_order(container_id);

    if (typeof order_value == 'string')
    {
        za = '';

        if (axis == '_recno_')
        {
            set_container_order(container_id, '');
        }
        else
        {
            switch (order_value)
            {
            case axis:
                set_container_order(container_id, 'za,' + axis);
                za = ' (decending)';
                break;
            case 'za,' + axis:
            default:
                set_container_order(container_id, axis);
                break;
            }
        }

        if (row)
        {
            var title = '';
            var indicator = String.fromCharCode(8201) + String.fromCharCode(9830) + String.fromCharCode(8201); // &thinsp;&diams;&thinsp;

            for (var i = 0; i < row.cells.length; i++)
            {
                if (row.cells[i].innerHTML.indexOf(indicator) >= 0)
                {
                    row.cells[i].innerHTML = row.cells[i].innerHTML.replace(indicator , '');
                    break;
                }
            }

            if (row.cells[c].innerHTML && row.cells[c].innerHTML != '&nbsp;')
            {
                title = "Sort Order: " + row.cells[c].innerHTML + za;
                row.cells[c].innerHTML = !za ?  indicator + row.cells[c].innerHTML : row.cells[c].innerHTML + indicator ;
            }

            row.title = title;
        }

        do_nav_first(container_id);
    }
}

////

/*
//document.onmousemove = doXY; // TODO: experimental

function doXY(e)
{
    e = e ? e : window.event;

    var mouseX = e.clientX;
    var mouseY = e.clientY;

    var windowX = (document.documentElement && document.documentElement.clientWidth) || window.innerWidth || self.innerWidth || document.body.clientWidth;
    var windowY = (document.documentElement && document.documentElement.clientHeight) || window.innerHeight || self.innerHeight || document.body.clientHeight;
    var scrollX = (document.documentElement && document.documentElement.scrollLeft) || window.pageXOffset || self.pageXOffset || document.body.scrollLeft;
    var scrollY = (document.documentElement && document.documentElement.scrollTop) || window.pageYOffset || self.pageYOffset || document.body.scrollTop;
    var pageX = (document.documentElement && document.documentElement.scrollWidth) ? document.documentElement.scrollWidth : (document.body.scrollWidth > document.body.offsetWidth) ? document.body.scrollWidth : document.body.offsetWidth;
    var pageY = (document.documentElement && document.documentElement.scrollHeight) ? document.documentElement.scrollHeight : (document.body.scrollHeight > document.body.offsetHeight) ? document.body.scrollHeight : document.body.offsetHeight;

    var posX = mouseX + scrollX;
    var posY = mouseY + scrollY;

    var width = document.width || pageX;
    var height = document.height || pageY;

    var msg = '';

    msg += 'pageX: ' + pageX + ', pageY: ' + pageY + '<br><br>';

    msg += 'w: ' + width + ', h: ' + height + '<br><br>';

    msg += 'x: ' + mouseX + ', ' + 'y:' + mouseY + '<br>';
    msg += 'posX: ' + posX + ', ' + 'posY:' + posY + '<br>';
    msg += 'windowX: ' + windowX + ', windowY: ' + windowY + '<br>';
    msg += 'scrollX: ' + scrollX + ', scrollY: ' + scrollY + '<br>';

    set_container_msg_markup(msg);
}
*/

////

//
// wrappers
//

g_reg_cxlrefs = Array();

function put_cxlref(key, cxlref)
{
    if (typeof key == 'number' && typeof cxlref == 'object')
    {
        g_reg_cxlrefs[key] = cxlref;
    }
}

function get_cxlref(key)
{
    var cxlref = null;

    switch (typeof key)
    {
    case 'string':
        key = get_container_nav(key);
        break;
    case 'number':
        break;
    default:
        key = null;
        break;
    }

    if (g_reg_cxlrefs[key])
    {
        cxlref = g_reg_cxlrefs[key];
    }

    return cxlref;
}

function reset_goal()
{
    var cxlref = get_cxlref(0);

    if (cxlref)
    {
        cxlref.send_request("_goal_reset_");
    }
}

////

function do_exchange(id)
{
    var cxlref = get_cxlref(id);

    if (cxlref)
    {
        cxlref.set_container(id);
        cxlref.send_request();
        cxlref.set_container(); // TODO: temp
    }
}

////

function do_search(id, tform_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        do_nav_first(tform_id, id);
    }
}

function do_reset(id, tform_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        form_reset(id);
        do_nav_first(tform_id, id);
    }
}

function do_nav_first(id, sform_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.set_filter(id, sform_id);
            cxlref.nav_first();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_nav_up(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.nav_up();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_nav_dn(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.nav_dn();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_nav_last(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.nav_last();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_nav_close(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.nav_close();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_nav_select(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.nav_select();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_add(id, iform_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.m_iform_id = (typeof iform_id == 'string') ? iform_id : '' ;
            cxlref.add();
            cxlref.set_container(); // TODO: temp
            cxlref.m_iform_id = ''; // TODO: temp
        }
    }
}

function do_edit(id, iform_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.m_iform_id = (typeof iform_id == 'string') ? iform_id : '' ;
            cxlref.edit();
            cxlref.set_container(); // TODO: temp
            cxlref.m_iform_id = ''; // TODO: temp
        }
    }
}

function do_delete(id, iform_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.m_iform_id = (typeof iform_id == 'string') ? iform_id : '' ;
            cxlref._delete();
            cxlref.set_container(); // TODO: temp
            cxlref.m_iform_id = ''; // TODO: temp
        }
    }
}

function do_cancel(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(id);

        if (cxlref)
        {
            cxlref.set_container(id);
            cxlref.cancel();
            cxlref.set_container(); // TODO: temp
        }
    }
}

function do_submit(form_id)
{
    if (typeof m_map_id_onsubmit[form_id] == 'function')
    {
        m_map_id_onsubmit[form_id](); // NOTE: related machinery prevents multiple requests
    }
}

////

function do_exchange1b(id)
{
    g_cxlref1b.set_container(id);
    g_cxlref1b.send_request();
    g_cxlref1b.set_container(); // TODO: temp
}

function do_add1b(select_id, input_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(select_id);
        var qid = get_container_qid(select_id);

        if (cxlref && qid)
        {
            g_cxlref1b = new cxl(cxlref.get_page_id() + '_' + qid + '_1b', qid);
//            g_cxlref1b.set_show_response(true);

            g_cxlref1b.m_request_guidance = cxlref.get_page_id() + ';' + cxlref.m_request_objective; // TODO: KLUGE:
            g_cxlref1b.m_request_limit_offset = cxlref.m_request_limit_offset; // TODO: KLUGE:

            g_cxlref1b.set_container(select_id);
            g_cxlref1b.m_iform_id = (typeof input_id == 'string') ? input_id : '' ;

            g_cxlref1b.add();
            g_cxlref1b.set_container(); // TODO: temp
            g_cxlref1b.m_iform_id = ''; // TODO: temp
        }
    }
}

function do_edit1b(select_id, input_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(select_id);
        var qid = get_container_qid(select_id);

        if (cxlref && qid)
        {
            g_cxlref1b = new cxl(cxlref.get_page_id() + '_' + qid + '_1b', qid);
//            g_cxlref1b.set_show_response(true);

            g_cxlref1b.m_request_guidance = cxlref.get_page_id() + ';' + cxlref.m_request_objective; // TODO: KLUGE:
            g_cxlref1b.m_request_limit_offset = cxlref.m_request_limit_offset; // TODO: KLUGE:

            g_cxlref1b.set_container(select_id);
            g_cxlref1b.m_iform_id = (typeof input_id == 'string') ? input_id : '' ;

            g_cxlref1b.edit();
            g_cxlref1b.set_container(); // TODO: temp
            g_cxlref1b.m_iform_id = ''; // TODO: temp
        }
    }
}

function do_delete1b(select_id, input_id, control)
{
    if (!nav_control_is_disabled(control))
    {
        var cxlref = get_cxlref(select_id);
        var qid = get_container_qid(select_id);

        if (cxlref && qid)
        {
            g_cxlref1b = new cxl(cxlref.get_page_id() + '_' + qid + '_1b', qid);
//            g_cxlref1b.set_show_response(true);

            g_cxlref1b.m_request_guidance = cxlref.get_page_id() + ';' + cxlref.m_request_objective; // TODO: KLUGE:
            g_cxlref1b.m_request_limit_offset = cxlref.m_request_limit_offset; // TODO: KLUGE:

            g_cxlref1b.set_container(select_id);
            g_cxlref1b.m_iform_id = (typeof input_id == 'string') ? input_id : '' ;

            g_cxlref1b._delete();
            g_cxlref1b.set_container(); // TODO: temp
            g_cxlref1b.m_iform_id = ''; // TODO: temp
        }
    }
}

function do_cancel1b(id, control)
{
    if (!nav_control_is_disabled(control))
    {
        g_cxlref1b.set_container(id);
        g_cxlref1b.cancel();
        g_cxlref1b.set_container(); // TODO: temp
    }
}

////

function do_app_nav(nav_container_id)
{
    if (typeof g_search_app_nav == 'undefined' || (typeof g_search_app_nav == 'string' && eval(g_search_app_nav)))
    {
        var app_nav_request = new cxl(get_page_id());
//        app_nav_request.set_show_response(true);
        app_nav_request.set_request_mode_adhoc();
        app_nav_request.set_container(nav_container_id);
        app_nav_request.append_request_extra_args('document_pathname', document.location.pathname);
        app_nav_request.send_request('_app_nav_');
        hide_show(nav_container_id, 'show');
    }
}

//
// symbolic constants
//

eval(var_const + "ID_PAGE_CONTENT        = 'id_page_content';");
eval(var_const + "ID_PAGE_CONTENT_REMOTE = 'id_page_content_remote';");
eval(var_const + "REMOTE_IFRAME = 'remote_iframe';");
eval(var_const + "REMOTE_CXL = 'g_cxl';");

////

var g_remote_select = null;

////

var remote = function(parent)
{
    this.init();
    this.m_parent = parent;
}

remote.prototype.init = function()
{
    this.m_parent = null;
    this.m_container = null;
    this.m_end_func = null;
    this.m_buffer_id = null;
    this.m_map_key_index = Array();
}

remote.prototype.accept = function(container, end_func)
{
    var request_sent = false;

    if (typeof end_func == "function")
    {
        this.m_end_func = end_func;

        if (this.m_parent &&
            typeof container == "object" &&
            container &&
            container.options &&
            container.options.length)
        {
            this.m_container = container;

            for (var i = 0; i < this.m_container.options.length; i++)
            {
                this.m_map_key_index[this.m_container.options[i].value] = i;
            }

            if (this.m_parent.m_remote_container_id)
            {
//                this.m_parent.set_show_response(true);
                this.m_parent.set_container(this.m_parent.m_remote_container_id);
                this.m_parent.set_request_mode_batch();
                this.m_parent.nav_first();
                this.m_parent.request_mode_conditional_reset();

                request_sent = true;
            }
        }
    }

    if (!request_sent)
    {
        this.process(); // abort
    }
}

remote.prototype.process = function()
{
    if (this.m_parent && this.m_parent.m_response_remote.length > 0)
    {
        var keys = this.m_parent.m_response_remote.split(","); // TODO: KLUGE: do this without allocating space for another copy of the data

        if (keys && keys.length)
        {
            for (var i = 0; i < keys.length; i++)
            {
                var r = typeof this.m_map_key_index[keys[i]] != 'undefined' ? this.m_map_key_index[keys[i]] : -1 ;

                if (r >= 0 && r < this.m_container.options.length)
                {
                    this.m_container.options[r].selected = true;
                }
                else
                {
                    alert('unexpected key: ' + keys[i]);
                }
            }
        }
    }

    this.close(); // TODO: temp
}

remote.prototype.close = function()
{
    if (typeof this.m_end_func == "function")
    {
        this.m_end_func();
    }
}

////

var remote_select = function()
{
    this.m_select_element = null;
    this.m_remote_url = null;
}

/*
remote_select.prototype.open_remote = function(select_id, remote_url)
{
    if (typeof remote_url == "string" &&
        (this.m_remote_url = trim(remote_url)))
    {
//        if (window.frames[REMOTE_IFRAME].document.location.toString().indexOf(this.m_remote_url) < 0)
        {
            window.frames[REMOTE_IFRAME].document.location = this.m_remote_url;
        }

//        hide_show(ID_PAGE_CONTENT, 'hide');
        hide_show(ID_PAGE_CONTENT_REMOTE, 'show');
    }
}
*/
remote_select.prototype.open_remote = function(select_id, remote_url)
{
    if (typeof select_id == "string" &&
        typeof remote_url == "string" &&
        (this.m_remote_url = trim(remote_url)) &&
        (this.m_select_element = document.getElementById(trim(select_id))) &&
        this.m_select_element.nodeName.toLowerCase() == "select")
    {

        if (window.frames[REMOTE_IFRAME].document.location.toString().indexOf(this.m_remote_url) < 0)
        {
            window.frames[REMOTE_IFRAME].document.location = this.m_remote_url;
        }

        hide_show(ID_PAGE_CONTENT, 'hide');
        hide_show(ID_PAGE_CONTENT_REMOTE, 'show');
    }
}

remote_select.prototype.accept = function()
{
    window.frames[REMOTE_IFRAME].window[REMOTE_CXL].remote_accept(this.m_select_element, this.close_remote);
}

remote_select.prototype.close_remote = function()
{
    hide_show(ID_PAGE_CONTENT_REMOTE, 'hide');
    hide_show(ID_PAGE_CONTENT, 'show');
    window.frames[REMOTE_IFRAME].document.location = 'iempty.htm?reload'; // TODO: define constants
}

////

//
// wrappers
//

function do_close_remote()
{
    hide_show(ID_PAGE_CONTENT_REMOTE, 'hide');
    hide_show(ID_PAGE_CONTENT, 'show');
    window.frames[REMOTE_IFRAME].document.location = 'iempty.htm?reload'; // TODO: define constants
}

function do_browse(select_id, remote_url)
{
    if (!g_remote_select)
    {
        g_remote_select = new remote_select();
    }

    g_remote_select.open_remote(select_id, remote_url);
}

function do_accept()
{
    if (g_remote_select)
    {
        g_remote_select.accept();
    }
}

////

var m_lookup_request = Array();

function reg_lookup(container_id, details)
{
    if (container_id)
    {
        if (!m_lookup_request[container_id])
        {
            m_lookup_request[container_id] = Array();
        }

        m_lookup_request[container_id].push(details);
    }
}

function lookup_all(container_id)
{
    if (container_id && m_lookup_request[container_id])
    {
        for (var i in m_lookup_request[container_id])
        {
            var details = m_lookup_request[container_id][i];

            if (details.select_id)
            {
                var selected_keys = get_selected_keys(document.getElementById(details.select_id));

                if (selected_keys && selected_keys.length && selected_keys[0])
                {
                    var pk = selected_keys[0];
                    do_lookup(null, container_id, details.qid, pk); // independent
                }
            }
            else if (details.basis_id)
            {
                var control = document.getElementById(details.basis_id);

                if (control)
                {
                    do_lookup(control, container_id, details.qid); // select list control
                }
            }
        }
    }
}

function process_change(control)
{
    if (control && control.id)
    {
        for (var container_id in m_lookup_request)
        {
            for (var i in m_lookup_request[container_id])
            {
                var details = m_lookup_request[container_id][i];

                if (details.basis_id == control.id)
                {
                    do_lookup(control, container_id, details.qid);
                    return;
                }
            }
        }
    }
}

////

var m_stat_request = Array();

function reg_stat(parent_id, details)
{
    if (parent_id && details && details.container_id && details.qid)
    {
        reg_blind(details.container_id);

        if (!m_stat_request[parent_id])
        {
            m_stat_request[parent_id] = Array();
        }

        m_stat_request[parent_id].push(details);
    }
}

function stat_all(pid, objective, parent_id)
{
    if (pid && objective && parent_id && m_stat_request[parent_id])
    {
        for (var i = 0; i < m_stat_request[parent_id].length; i++)
        {
            var details =  m_stat_request[parent_id][i];

            do_stat(pid, objective, details.qid, details.container_id);
        }
    }
}

////

function handler_keyup(e)
{
    var result = true; // no change to default behavior

    if (m_page_id)
    {
        if (!e) var e = window.event;

        var c = 0;

        if (e.keyCode)
        {
            c = e.keyCode;
        }
        else if (e.which)
        {
            c = e.which;
        }
            var t = null;

            if (e.target)
            {
                t = e.target;
            }
            else if (e.srcElement)
            {
                t = e.srcElement;
            }

//window.status = t.id;

        if (c /*&& (e.ctrlKey || e.shiftKey || e.altKey)*/)
        {
            result = false; // override default behavior

            switch (c)
            {
            case 27: // Esc
                do_nav_close(m_page_id);
                break;
            case 33: // PgUp
                do_nav_up(m_page_id);
                break;
            case 34: // PgDn
                do_nav_dn(m_page_id);
                break;
            case 35: // End
                do_nav_last(m_page_id);
                break;
            case 36: // Home
                do_nav_first(m_page_id);
                break;
            default:
                result = true; // restore default behavior
                break;
            }
        }
    }

    return result;
}

//document.onkeyup = handler_keyup; // TODO: gotta do better than this

/*
if (typeof window.addEventListener == 'function')
{
    window.addEventListener('keyup', handler_keyup, false);
}
else if (typeof window.attachEvent != 'undefined')
{
    window.attachEvent('onkeyup', handler_keyup);
}
*/

////

var m_code = 0;

function listener_keydown(e)
{
    if (!e) var e = window.event;

    if (!m_code)
    {
        var c = 0;

        if (e.keyCode)
        {
            c = e.keyCode;
        }
        else if (e.which)
        {
            c = e.which;
        }

        if (c)
        {
            switch (c)
            {
            case 13: // Enter
            case 27: // Esc
                m_code = c;
                break;
            case 33: // PgUp
            case 34: // PgDn
                break;
            default:
                break;
            }
        }
    }
}

function listener_keyup(e)
{
    if (!e) var e = window.event;

    if (m_code)
    {
        var c = 0;

        if (e.keyCode)
        {
            c = e.keyCode;
        }
        else if (e.which)
        {
            c = e.which;
        }

        if (m_code == c)
        {
            m_code = 0;

            var t = null;

            if (e.target)
            {
                t = e.target;
            }
            else if (e.srcElement)
            {
                t = e.srcElement;
            }

            if (t)
            {
                switch (c)
                {
                case 13: // Enter
                    if (t.form && t.form.id)
                    {
                        do_submit(t.form.id);
                    }
                    break;
                case 27: // Esc
                    if (t.form && t.form.id)
                    {
                        do_cancel1b(t.form.id);
                    }
                    break;
                case 33: // PgUp
                case 34: // PgDn
                    break;
                default:
                    break;
                }
            }
        }
    }
}

function add_key_listener(id)
{
    var element = document.getElementById(id);

    if (element)
    {
        if (typeof element.addEventListener == 'function')
        {
            element.addEventListener('keydown', listener_keydown, false);
            element.addEventListener('keyup', listener_keyup, false);
        }
        else if (typeof element.attachEvent != 'undefined')
        {
            element.attachEvent('onkeydown', listener_keydown);
            element.attachEvent('onkeyup', listener_keyup);
        }
    }
}

////

function handler_resize(e)
{
/*
    var windowX = (document.documentElement && document.documentElement.clientWidth) || window.innerWidth || self.innerWidth || document.body.clientWidth;
    var windowY = (document.documentElement && document.documentElement.clientHeight) || window.innerHeight || self.innerHeight || document.body.clientHeight;

    var element = document.getElementById(m_screen_id);

    if (element)
    {
        element.style.width = windowX + 'px';
        element.style.height = windowY + 'px';
    }
*/
    var content_element = document.getElementById(m_content_id);
    var screen_element = document.getElementById(m_screen_id);

    if (content_element && screen_element)
    {
        screen_element.style.width = content_element.scrollWidth + 'px';
        screen_element.style.height = content_element.scrollHeight + 'px';
    }
}

function handler_onscroll()
{
    if (IS_MSIE)
    {
        fixed_float_pos(document.getElementById(m_control_bar_id));
    }
}

window.onresize = handler_resize;
//window.onscroll = handler_onscroll;

////

var m_screen_id = 'id__iform__screen'; // TODO: HACK: KLUGE:
var m_iform_div_id = 'id_iform_div'; // TODO: HACK: KLUGE:
var m_content_id = 'id_page_content'; // TODO: HACK: KLUGE:
var m_page_msg_id = 'id_page_msg'; // TODO: HACK: KLUGE:
var m_control_bar_id = 'id_control_bar'; // TODO: HACK: KLUGE:
//var m_control_bar_caption_id = 'id_control_bar_caption'; // TODO: HACK: KLUGE:
//var m_control_bar_prompt_id = 'id_control_bar_prompt'; // TODO: HACK: KLUGE:
//var m_control_bar_controls_id = 'id_control_bar_controls'; // TODO: HACK: KLUGE:
var m_page_id = null;
var m_basis_select_id = null;

var m_map_overlay_id = Array();
var m_map_id_overlay = Array();
var m_map_role_id = Array();
var m_map_id_role = Array();
var m_map_id_nav_flags = Array();
var m_map_id_args = Array();
var m_map_id_onsubmit = Array();
var m_map_id_is_blind = Array();
var m_map_qid_id = Array();

////

function reg_overlay(id_overlay, id_element, role, nav_flags)
{
    // TODO: check to make sure id_element isn't in another overlay

    if (!role.startsWith('stat:'))
    {
        if (!m_map_overlay_id[id_overlay])
        {
            m_map_overlay_id[id_overlay] = Array();
        }

        m_map_overlay_id[id_overlay].push(id_element);

        if (!m_map_id_overlay[id_element])
        {
            m_map_id_overlay[id_element] = id_overlay;
        }
    }

    m_map_role_id[role] = id_element;
    m_map_id_role[id_element] = role;
    m_map_id_nav_flags[id_element] = nav_flags;

    if (role.startsWith('select:') && nav_flags.contains('basis'))
    {
        m_basis_select_id = id_element;
    }

    var role_tokens = role.split(':');

    if (role_tokens && role_tokens.length == 3)
    {
        var qid = role_tokens[2];

        if (!m_map_qid_id[qid])
        {
            m_map_qid_id[qid] = Array();
        }

        m_map_qid_id[qid].push(id_element);
    }
}

function get_basis_select_id()
{
    return m_basis_select_id;
}

function is_basis_select_container(container_id)
{
    return container_id && container_id == m_basis_select_id;
}

function find_container_id_by_role(role)
{
    return m_map_role_id[role] ? m_map_role_id[role] : null ;
}

function find_container_role_by_id(id)
{
    return m_map_id_role[id] ? m_map_id_role[id] : '' ;
}

function find_container_id_by_role_prefix(container_id, role_prefix_key)
{
    var result = null;

    var group = null;
    var group_ids = null;

    if (container_id &&
        role_prefix_key &&
        m_map_id_overlay[container_id] &&
        (group = m_map_id_overlay[container_id]) &&
        m_map_overlay_id[group] &&
        (group_ids = m_map_overlay_id[group]))
    {
        for (var i = 0; i < group_ids.length; i++)
        {
            var id = group_ids[i];

            if (id && id != container_id)
            {
                var role = find_container_role_by_id(id);

                if (role && role.startsWith(role_prefix_key))
                {
                    result = id;
                    break;
                }
            }
        }
    }

    return result;
}

function find_container_nav_flags_by_id(id)
{
    return m_map_id_nav_flags[id] ? m_map_id_nav_flags[id] : '' ;
}

function find_constraint_select_container()
{
    var id = null;

    for (var container_id in m_map_id_nav_flags)
    {
        if (find_container_nav_flags_by_id(container_id).contains('constraint') &&
            find_container_role_by_id(container_id).contains('select:'))
        {
            var element = document.getElementById(container_id);

            if (element)
            {
                id = element;
            }
        }
    }

    return id;
}

function find_key_select_containers()
{
    var ids = Array();

    for (var container_id in m_map_id_nav_flags)
    {
        if (find_container_nav_flags_by_id(container_id).contains('key') &&
            find_container_role_by_id(container_id).contains('select:'))
        {
            var element = document.getElementById(container_id);

            if (element)
            {
                ids.push(element);
            }
            else
            {
                // TODO: TBD: error msg??
            }
        }
    }

    return ids;
}

function customize_background()
{
    if (g_appid)
    {
        var background = find_css_element('#id_body_' + g_appid, 'background');

        if (typeof background == 'string' && background.length)
        {
            document.body.style.background = background;
        }
    }
}

function find_screen_id_for_container(id)
{
    var screen_id = null;

    for (var role in m_map_role_id)
    {
        if (role.startsWith('input:') && m_map_role_id[role] == id)
        {
            screen_id = m_screen_id;
            break;
        }
    }

    return screen_id;
}

function set_compatible_screen()
{
    if (IS_MSIE6)
    {
        var old_screen = find_css_element('#id__iform__screen', 'background');

        if (typeof old_screen == 'string' && old_screen.length)
        {
            var new_screen = old_screen.replace('.png', '.gif');

            if (new_screen != old_screen)
            {
                replace_css_element('#id__iform__screen', 'background', new_screen);
            }
        }

        old_screen = find_css_element('#id_page_content_remote', 'background');

        if (typeof old_screen == 'string' && old_screen.length)
        {
            var new_screen = old_screen.replace('.png', '.gif');

            if (new_screen != old_screen)
            {
                replace_css_element('#id_page_content_remote', 'background', new_screen);
            }
        }
    }
}

// one-time initialization
//
function do_init()
{
    customize_background();

    // set initial state
    //
    for (var role in m_map_role_id)
    {
        if (role.startsWith('search:') || role.startsWith('input:'))
        {
            add_key_listener(map_onsubmit(m_map_role_id[role]));
        }
        else if (role.startsWith('select:'))
        {
            manage_nav_controls(document.getElementById(m_map_role_id[role]), {disable_all:true});
        }
    }

    // support legacy browser
    //
    set_compatible_screen(); // HACK: KLUGE: MSIE6

    // leave some bread crumbs
    //
    set_page_mark_attrs();
}

////

function set_page_mark_attrs()
{
    var pid = get_page_id();

    if (pid && pid != 'welcome' && pid != 'login' && pid != 'logout')
    {
        if (g_appid == 'synapp2')
        {
            set_synapp2_cookie(g_appid, document.title + '@' + document.URL);
        }
        else
        {
            set_synapp2_cookie(g_appid, g_appid + ' ' + document.title + '@' + document.URL);
        }
    }
}

function get_page_mark_attrs()
{
    var attrs = null;

    var pid = get_page_id();

    if (pid && pid != 'welcome' && pid != 'login' && pid != 'logout')
    {
        var appid = get_cookie('appid'); // NOTE: only synapp2 pages set_cookie('appid')

        if (appid)
        {
            var tokens = get_cookie(g_appid == 'synapp2' ? appid : 'synapp2').split('@');

            if (tokens && tokens.length == 2)
            {
                var sep = tokens[0].indexOf(' ');

//                var app = tokens[0].substring(0, sep);
//                var page = tokens[0].substring(sep);

                attrs = {app:tokens[0].substring(0, sep), title:tokens[0].substring(sep), url:tokens[1]};
            }
        }
    }

    return attrs;
}

function set_mark_appid_db(appid_db)
{
    set_session_cookie('appid', appid_db);
    set_container_msg_markup('');
}

function get_mark_appid_db()
{
    return get_cookie('appid');
}

////

function map_onsubmit(container_id)
{
    var form_id = null;

    var container = document.getElementById(container_id);

    if (container)
    {
        var nodeName = container.nodeName.toLowerCase();

        var form_elements = nodeName == 'form' ? Array(container) : container.getElementsByTagName('form');

        if (form_elements &&
            form_elements.length &&
            form_elements[0].id &&
            typeof form_elements[0].onsubmit == 'function')
        {
            form_id = form_elements[0].id;
            m_map_id_onsubmit[form_id] = form_elements[0].onsubmit;
            form_elements[0].onsubmit = function() { return false; };
        }
    }

    return form_id;
}

////

function set_caption(text)
{
    set_element_text_by_id(m_control_bar_caption_id, text);
}

function set_prompt(text)
{
    set_element_text_by_id(m_control_bar_prompt_id, text);
}

function set_controls(c)
{
}

////

function add_or_replace_action(actions, candidate_action)
{
    var add_flag = true;

    for (var i = 0; i < actions.length; i++)
    {
        if (candidate_action.id == actions[i].id)
        {
            if (candidate_action.display == 'show')
            {
                actions[i] = candidate_action; // replace -- 'show' trumps all other display states
            }

            add_flag = false;
            break;
        }
    }

    if (add_flag)
    {
        actions.push(candidate_action); // add
    }
}

function xshow(role_csv)
{
    var roles = null;

    if (typeof role_csv == 'string' && (roles = role_csv.split(",")))
    {
        var input_id = null;
        var actions = Array();
        var to_front = Array();

        var rollup_select_id = null;
        var rollup_stat_id = null;
        var rollup_search_id = null;
        var rollup_display_id = null;

        var focus_id = null;
        var page_id = null;
        var is_rollup = false;

        ////

        for (var r = 0; r < roles.length; r++)
        {
            var role = roles[r];

            if (role.startsWith('rollup:'))
            {
                rollup_select_id = find_container_id_by_role(role.replace('rollup:', 'select:'));
                rollup_stat_id = find_container_id_by_role(role.replace('rollup:', 'stat:'));
                rollup_search_id = find_container_id_by_role(role.replace('rollup:', 'search:'));
                rollup_display_id = find_container_id_by_role(role.replace('rollup:', 'display:'));

                add_or_replace_action(actions, {id:rollup_select_id, display:'default', zIndex:null});
                add_or_replace_action(actions, {id:rollup_search_id, display:'default', zIndex:null});
                add_or_replace_action(actions, {id:rollup_display_id, display:'default', zIndex:null});

                ////

                is_rollup = true;

                continue;
            }

            var container_id = find_container_id_by_role(role);
            var nav_flags = find_container_nav_flags_by_id(container_id);

            if (role.startsWith('display:'))
            {
                add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'search:'), display:'hide', zIndex:null});
                add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'select:'), display:'hide', zIndex:null});
                add_or_replace_action(actions, {id:container_id, display:'show', zIndex:null});
            }
            else if (role.startsWith('search:'))
            {
                add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'display:'), display:'hide', zIndex:null});

                if (container_id != rollup_search_id && !nav_flags.contains('basis') && !nav_flags.contains('key') && role_csv.contains('select:'))
                {
                    to_front.push(container_id);
                }
                else
                {
                    add_or_replace_action(actions, {id:container_id, display:'show', zIndex:null});
                }

                focus_id = container_id;
            }
            else if (role.startsWith('select:'))
            {
                if (container_id != rollup_select_id && !nav_flags.contains('basis') && !nav_flags.contains('key'))
                {
                    to_front.push(container_id);
                }
                else
                {
                    add_or_replace_action(actions, {id:container_id, display:'default', zIndex:null});
                }

                if (!is_rollup)
                {
                    focus_id = null; // prevent focus change to search:, unless rollup
                }

                page_id = container_id;
            }
            else if (role.startsWith('input:'))
            {
                if (nav_flags.contains('basis'))
                {
                    // hide basis select controls
                }
                else if (nav_flags.contains('key'))
                {
                    // hide key search controls
                    // hide key select controls
                    // hide basis select controls
                }
                else if (nav_flags.contains('tier'))
                {
                    add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'select:'), display:'default', zIndex:null});
                    add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'search:'), display:'default', zIndex:null});
                    // hide search controls
//                    add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'display:'), display:'default', zIndex:null});
                }
                else if (nav_flags.contains('mid'))
                {
                    add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'select:'), display:'default', zIndex:null});
                    add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'search:'), display:'show', zIndex:null});
                    // hide search controls or show display form
//                    add_or_replace_action(actions, {id:find_container_id_by_role_prefix(container_id, 'display:'), display:'default', zIndex:null});
                }

                input_id = focus_id = container_id;
                to_front.push(input_id);
            }
        }

        ////

        for (var id_element in m_map_id_role)
        {
            if (id_element != input_id &&
                m_map_id_role[id_element] &&
                m_map_id_role[id_element].startsWith('input:'))
            {
                hide_show(id_element, 'hide');
            }
        }

        ////

        if (!to_front.length)
        {
            hide_show(m_screen_id, 'hide');
        }
        else
        {
            hide_show(m_screen_id, 'show', 1);
        }

        ////

        if (!input_id)
        {
            hide_show(m_iform_div_id, 'hide');
        }
        else
        {
            var screen_pos = get_pos(document.getElementById(m_screen_id))
            var element = document.getElementById(m_iform_div_id);

            if (element)
            {
                // shift the iform into the viewport - if and as needed
                element.style.top = Math.max(screen_pos.top, get_viewport_offset_top()) + 'px';
                element.style.left = Math.max(screen_pos.left, get_viewport_offset_left()) + 'px';
            }

            ////

            hide_show(m_iform_div_id, 'show', 2);
        }

        ////

        for (var a = 0; a < actions.length; a++)
        {
            var action = actions[a];
            hide_show(action.id, action.display, action.zIndex);
        }

        ////

        if (to_front.length)
        {
            for (var f = 0; f < to_front.length; f++)
            {
                hide_show(to_front[f], 'show', 2);
            }

            handler_resize();
        }

        ////

        if (rollup_select_id)
        {
            var select_nav_flags = find_container_nav_flags_by_id(rollup_select_id);

            if (select_nav_flags.contains('basis') || select_nav_flags.contains('key'))
            {
                resize_container(rollup_select_id, 1); // TODO: make compatable with table having fixed number of rows

                var xmgr = new csx(rollup_select_id);

                for (var r = 0; r < xmgr.get_row_count(); r++)
                {
                    xmgr.set_pk(r, '');

                    for (var c = 0; c < xmgr.get_col_count(); c++)
                    {
                        xmgr.set_cell_by_row_col(r, c, '');
                    }
                }
            }

            clr_select_state_all(rollup_select_id);
            manage_nav_controls(document.getElementById(rollup_select_id), {disable_all:true});
        }

        if (rollup_stat_id)
        {
            form_reset(rollup_stat_id);
        }

        if (rollup_search_id)
        {
//            form_reset(rollup_search_id);
        }

        if (rollup_display_id)
        {
            form_reset(rollup_display_id);
        }

        ////

        m_page_id = page_id;

        if (focus_id)
        {
            set_container_focus(focus_id);
        }
    }
}

////

function set_element_text(element, text)
{
    element.innerHTML = text; // TODO: more complete and robust
}

function set_element_text_by_id(id, text)
{
    var element = document.getElementById(id);

    if (element)
    {
        set_element_text(element, text);
    }
}

////

function get_element_style_property_value(element, name_CSS, name_IE)
{
    var style_property_value = '';

    if (element.currentStyle)
    {
        // IE browser
        var name = (typeof name_IE == "string") ? name_IE : name_CSS ;
        style_property_value = element.currentStyle[name];
    }
    else if (window.getComputedStyle)
    {
        // w3c browser
        try
        {
            style_property_value = document.defaultView.getComputedStyle(element, null).getPropertyValue(name_CSS);
        }
        catch (ex)
        {
            alert("no style_property_value for element.id: " + element.id + ", " + name_CSS);
        }
    }

    return style_property_value;
}

////

function get_pos(element)
{
    var curleft = 0;
    var curtop = 0;

    while (element)
    {
        curleft += element.offsetLeft;
        curtop += element.offsetTop;

        element = element.offsetParent;
    }

    return {top:curtop, left:curleft};
}

function float_pos(element, pad_left, pad_top)
{
    if (element)
    {
        if (typeof pad_left != "number")
        {
            pad_left = 0;
        }

        if (typeof pad_top != "number")
        {
            pad_top = 0;
        }

        var ref_element = (document.compatMode && document.compatMode != "BackCompat") ? document.documentElement : document.body ;

        var pos_left = document.all ? ref_element.scrollLeft : pageXOffset;
        var pos_top = document.all ? ref_element.scrollTop : pageYOffset;

        element.style.left = (parseInt(pos_left) + pad_left) + "px";
        element.style.top = (parseInt(pos_top) + pad_top) + "px";
    }
}

function fixed_float_pos(element, pad_left, pad_top)
{
    if (IS_MSIE && element)
    {
        if (!document.compatMode ||
            document.compatMode == "BackCompat" ||
            navigator.userAgent.indexOf("MSIE 6.") > 0 ||
            navigator.userAgent.indexOf("MSIE 5.") > 0)
        {
            if (get_element_style_property_value(element, "position") != "absolute")
            {
                element.style.position = "absolute";
            }

            float_pos(element, pad_left, pad_top);
        }
    }
}

////

function get_viewport_offset_top()
{
    return window.pageYOffset ||
           document.documentElement.scrollTop ||
           document.body.scrollTop ||
           0;
}

function get_viewport_offset_left()
{
    return window.pageXOffset ||
           document.documentElement.scrollLeft ||
           document.body.scrollLeft ||
           0;
}

function get_viewport_offset()
{
    return {top:get_viewport_offset_top(), left:get_viewport_offset_left()}
}

////

function get_window_dimensions()
{
    var windowX = (document.documentElement && document.documentElement.clientWidth) || window.innerWidth || self.innerWidth || document.body.clientWidth;
    var windowY = (document.documentElement && document.documentElement.clientHeight) || window.innerHeight || self.innerHeight || document.body.clientHeight;

    return {x:windowX, y:windowY, width:windowX, height:windowY, top:0, right:windowX, bottom:windowY, left:0};
}

////

var m_default_style = Array();

function hide_show(id, state, zIndex)
{
    var element = null;

    if (element = document.getElementById(id))
    {
        var old_style = { display:"", top:"", left:"", zIndex:"" };

        old_style.display = get_element_style_property_value(element, "display");
        old_style.top = get_element_style_property_value(element, "top");
        old_style.left = get_element_style_property_value(element, "left");
        old_style.zIndex = get_element_style_property_value(element, "zIndex");

        ////

        if (!m_default_style[id])
        {
            m_default_style[id] = { display:old_style.display, top:old_style.top, left:old_style.left, zIndex:old_style.zIndex };
        }

        ////

        var new_style = { display:old_style.display, top:old_style.top, left:old_style.left, zIndex:old_style.zIndex };

        ////

        if (typeof state != 'string')
        {
            state = 'default';
        }

        if (typeof zIndex != 'number')
        {
            zIndex = m_default_style[id].zIndex;
        }

        ////

        switch (state)
        {
        case 'hide':
            new_style.display = "none";
            new_style.zIndex = m_default_style[id].zIndex;
            break;
        case 'show':
            new_style.display = m_default_style[id].display == "inline" ? "inline" : "block";
            new_style.zIndex = zIndex;
            break;
        default:
            alert('hide_show() - invalid state: ' + state);
            // drop thru
        case 'default':
            new_style.display = m_default_style[id].display;
            new_style.zIndex = m_default_style[id].zIndex;
            break;
        }

        ////

        element.style.zIndex = new_style.zIndex;
        element.style.display = new_style.display;
    }
}

function is_visible(id)
{
    var element = element = document.getElementById(id);

    return element && get_element_style_property_value(element, "display") != "none";
}

function set_container_focus(container_id)
{
    var container = container_id ? document.getElementById(container_id) : document ;

    if (container)
    {
        var nodeName = container.nodeName.toLowerCase();

        var form_elements = nodeName == "form" ? Array(container) : container.getElementsByTagName("form");

        if (form_elements &&
            form_elements.length &&
            form_elements[0].elements &&
            form_elements[0].elements.length)
        {
            var elements = form_elements[0].elements;

            if (elements && elements.length)
            {
                for (var i = 0; i < elements.length; i++)
                {
                    var form_element = elements[i];

                    if (!form_element.disabled &&
                        !form_element.readOnly &&
                        form_element.type != 'hidden' &&
                        form_element.type != 'none')
                    {
                        set_focus(form_element.id);
                        break;
                    }
                }
            }
        }
    }
}

function set_focus(id)
{
    var result = false;

    var element = null;

    if (element = document.getElementById(id))
    {
        try
        {
            element.focus();

            if (element.select)
            {
                element.select();
            }

            result = true;
        }
        catch (ex)
        {
            alert("Cannot set focus to: " + id);
        }
    }

    return result;
}

function forms_reset(container_node)
{
    if (!container_node || typeof container_node == 'undefined')
    {
        container_node = document;
    }

    var forms = container_node.getElementsByTagName("form");

    for (var i = 0; i < forms.length; i++)
    {
        forms[i].reset();
    }
}

function forms_focus()
{
    set_container_focus();
}

function form_reset(id)
{
    var element = document.getElementById(id);

    if (element)
    {
        if (element.tagName.toLowerCase() == "form")
        {
            element.reset();
        }
        else
        {
            forms_reset(element);
        }
    }
}

////

function find_css_element(selector_key, element_name)
{
    var result = null;

    var cssRules = !IS_MSIE ? 'cssRules' : 'rules' ;

    for (var S = 0; !result && S < document.styleSheets.length; S++)
    {
        for (var R = 0; !result && R < document.styleSheets[S][cssRules].length; R++)
        {
            if (document.styleSheets[S][cssRules][R].selectorText.contains(selector_key))
            {
                if (document.styleSheets[S][cssRules][R].style[element_name])
                {
                    result = document.styleSheets[S][cssRules][R].style[element_name];
                }
            }
        }
    }

    return result;
}

function replace_css_element(selector_key, element_name, value)
{
    var result = null;

    var cssRules = !IS_MSIE ? 'cssRules' : 'rules' ;

    for (var S = 0; !result && S < document.styleSheets.length; S++)
    {
        for (var R = 0; !result && R < document.styleSheets[S][cssRules].length; R++)
        {
            if (document.styleSheets[S][cssRules][R].selectorText.contains(selector_key))
            {
                if (document.styleSheets[S][cssRules][R].style[element_name])
                {
                    document.styleSheets[S][cssRules][R].style[element_name] = value;
                }
            }
        }
    }
}

////

var node_state = function(node)
{
    this.m_fgc = get_element_style_property_value(node, "color");
    this.m_bgc = get_element_style_property_value(node, "background-color", "backgroundColor");
    this.m_selected = false;
    this.m_node = node;
};

node_state.prototype.set_selected = function()
{
    this.m_node.style.color = this.m_bgc;
    this.m_node.style.backgroundColor = this.m_fgc;
    this.m_selected = true;
}

node_state.prototype.clr_selected = function()
{
    this.m_node.style.color = this.m_fgc;
    this.m_node.style.backgroundColor = this.m_bgc;
    this.m_selected = false;
}

node_state.prototype.is_selected = function()
{
    return this.m_selected == true;
}

var m_node_states = Array();

function set_select_state(id, sfx, node, release_node_flag)
{
    var key = id + '_' + sfx;

    if (m_node_states[key] && release_node_flag)
    {
        m_node_states[key] = null; // discard old node
    }

    if (!m_node_states[key])
    {
        m_node_states[key] = new node_state(node);
    }

    if (!m_node_states[key].is_selected() && detect_pk(node))
    {
        m_node_states[key].set_selected();
        on_select_state_change(id);
    }
}

// single row
//
function clr_select_state(id, sfx, release_node_flag)
{
    var key = id + '_' + sfx;

    if (m_node_states[key])
    {
        if (m_node_states[key].is_selected())
        {
            m_node_states[key].clr_selected();
            on_select_state_change(id);
        }

        if (release_node_flag)
        {
            m_node_states[key] = null;
        }
    }
}

// all rows
//
function clr_select_state_all(container_id, release_node_flag)
{
    var select_state_changed = false;

    for (var key in m_node_states)
    {
        if (typeof container_id == 'string' && !key.startsWith(container_id))
        {
            continue; // skip if supplied container_id does not match
        }

        if (m_node_states[key])
        {
            if (m_node_states[key].is_selected())
            {
                m_node_states[key].clr_selected();
                select_state_changed = true;
            }

            if (release_node_flag)
            {
                m_node_states[key] = null;
            }
        }
    }

    if (select_state_changed)
    {
        on_select_state_change(container_id);
    }
}

// all rows
//
function is_selection(container_id)
{
    var result = false;

    for (var key in m_node_states)
    {
        if (typeof container_id == 'string' && !key.startsWith(container_id))
        {
            continue; // skip if supplied container_id does not match
        }

        if (m_node_states[key] && m_node_states[key].is_selected())
        {
            result = true;
            break;
        }
    }

    return result;
}

function is_selection_short(container_id)
{
    var result = false;

    if (container_id)
    {
        if (find_container_nav_flags_by_id(container_id).contains('basis') &&
            find_container_role_by_id(container_id).contains('select:'))
        {
            var key_select_containers = find_key_select_containers();

            var constraint_select_container = find_constraint_select_container();

            if (constraint_select_container)
            {
                key_select_containers.push(constraint_select_container);
            }

            if (key_select_containers.length)
            {
                var keys_selected = 0;

                for (var i = 0; i < key_select_containers.length; i++)
                {
                    if (is_selection(key_select_containers[i].id))
                    {
                        keys_selected++;
                    }
                }

                if (keys_selected < key_select_containers.length)
                {
                    result = true; // not all foreign keys have been established
                }
            }
        }
    }

    return result;
}

function get_select_state(id, sfx)
{
    var key = id + '_' + sfx;

    return m_node_states[key] && m_node_states[key].is_selected();
}

function toggle_select_state(id, sfx, node)
{
    if (get_select_state(id, sfx))
    {
        clr_select_state(id, sfx);
    }
    else
    {
        set_select_state(id, sfx, node);
    }
}

function on_select_state_change(container_id)
{
    manage_nav_controls(document.getElementById(container_id), {selection_dependent_only:true});

    //    if (is_key_select_container(container_id))
    if (!is_basis_select_container(container_id))
    {
        manage_nav_controls(document.getElementById(get_basis_select_id()), {selection_dependent_only:true});
    }
}

function detect_pk(row_element)
{
    var result = false;

   if (row_element)
   {
        var row_cells = row_element.getElementsByTagName("td");

        if (row_cells && row_cells.length && row_cells[0].innerHTML)
        {
            var pk_value = trim(row_cells[0].innerHTML);  // TODO: HACK: KLUGE: ASSUME: cell[0] is pk value

            result = !(pk_value == '&nbsp;' || pk_value == '');
        }
    }

    return result;
}

////

function getArrayIndex(arr, val)
{
    var index = -1;

    if (typeof arr == 'object')
    {
        for (var i = 0; i < arr.length; i++)
        {
            if (arr[i] == val)
            {
                index = i;
                break;
            }
        }
    }

    return index;
}

////

/**
*
* trim functions adapted from code found at http://www.webtoolkit.info/
*
* without the second parameter, the functions will trim:
*   " " (ASCII 32 (0x20)), an ordinary space
*   "\t" (ASCII 9 (0x09)), a tab
*   "\n" (ASCII 10 (0x0A)), a new line (line feed)
*   "\r" (ASCII 13 (0x0D)), a carriage return
*   "\0" (ASCII 0 (0x00)), the NUL-byte
*   "\x0B" (ASCII 11 (0x0B)), a vertical tab
*
**/

function trim(str, chars)
{
    return ltrim(rtrim(str, chars), chars);
}

function ltrim(str, chars)
{
    chars = chars || "\\s";
    return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}

function rtrim(str, chars)
{
    chars = chars || "\\s";
    return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}

////

String.prototype.startsWith = function(s)
{
    return typeof s == 'string' && s.length && this.indexOf(s) == 0;
}

String.prototype.contains = function(s)
{
    return typeof s == 'string' && s.length && this.indexOf(s) >= 0;
}

String.prototype.endsWith = function(s)
{
    return typeof s == 'string' && this.search(s + '$') >= 0;
}

////

function in_array(a, v)
{
    if (typeof a == 'object')
    {
        for (var i in a)
        {
            if (a[i] === v)
            {
                return true;
            }
        }
    }

    return false;
}

////

function form_urlencode(eid)
{
    var args = "";

    if (eid)
    {
        var node = document.getElementById(eid);
        var elements = null;
        var element = null;
        var n = 1;

        if (node && node.nodeType == 1)
        {
            if ((elements = node.getElementsByTagName("input")) && elements.length)
            {
                var sep = "";

                for (var j = 0; j < elements.length; j++)
                {
                    if ((element = elements[j]) && element.type == "text")
                    {
                        var name = element.name ? element.name : ("unnamed" + n++);
                        var value = element.value;

                        args += (sep + encodeURI(name + "=" + value));
                        sep = "&";
                    }
                }
            }
        }
    }

    return args;
}

////

function nav_control_state_handler(control, flag_disable)
{
    if (control)
    {
        var nodeName = control.nodeName.toLowerCase();

        if (nodeName == 'img' || nodeName == 'input' || nodeName == 'button')
        {
            var img_src = control.getAttribute('src');

            if (img_src && img_src.contains('action_'))
            {
                var is_disabled = img_src.contains('_gray.');

                if (flag_disable && !is_disabled)
                {
                    control.setAttribute('src', img_src.replace('.gif', '_gray.gif')); // show disabled // TODO: HACK: KLUGE: .gif
                }
                else if (!flag_disable && is_disabled)
                {
                    control.setAttribute('src', img_src.replace( '_gray.', '.')); // show enabled
                }
            }

            if (typeof control.disabled == 'boolean')
            {
                control.disabled = flag_disable ? true : false ;
            }
        }
    }
}

function nav_control_is_disabled(control)
{
    var result = false;

    if (control)
    {
        var nodeName = control.nodeName.toLowerCase();

        if (nodeName == 'img' || nodeName == 'input' || nodeName == 'button')
        {
            var img_src = control.getAttribute('src');

            if (typeof control.disabled == 'boolean')
            {
                result = control.disabled ? true : false ;
            }
            else if (img_src && img_src.contains('action_'))
            {
                result = img_src.contains('_gray.') ? true : false ;
            }
        }
    }

    return result;
}

function manage_nav_controls(container, nav_flags)
{
    if (container && nav_flags)
    {
        var tag_names = ['img', 'input', 'button'];

        for (var t = 0; t < tag_names.length; t++)
        {
            var elements = container.getElementsByTagName(tag_names[t]);

            if (elements && elements.length)
            {
                for (var i = 0; i < elements.length; i++)
                {
                    var value = elements[i].getAttribute('onclick');

                    var func = '';

                    if (typeof value == 'string')
                    {
                        func = value;
                    }
                    else if (typeof value == 'function')
                    {
                        func = value.toString();
                    }

                    if (func && nav_flags.disable_all)
                    {
                        nav_control_state_handler(elements[i], true); // TODO: TBD: add control discriminator/filter
                    }
                    else if (nav_flags.selection_dependent_only)
                    {
                        if (func.indexOf('do_nav_select') >= 0 ||
                            func.indexOf('do_edit') >= 0 ||
                            func.indexOf('do_delete') >= 0)
                        {
                            nav_control_state_handler(elements[i], !container.id || !is_selection(container.id));
                        }
                        else if (func.indexOf('do_add') >= 0)
                        {
                            nav_control_state_handler(elements[i], !container.id || is_selection_short(container.id));
                        }
                    }
                    else if (func.indexOf('do_nav_select') >= 0 ||
                             func.indexOf('do_edit') >= 0 ||
                             func.indexOf('do_delete') >= 0)
                    {
                        nav_control_state_handler(elements[i], !container.id || !is_selection(container.id));
                    }
                    else if (func.indexOf('do_add') >= 0)
                    {
                        nav_control_state_handler(elements[i], !container.id || is_selection_short(container.id));
                    }
                    else if (func.indexOf('do_nav_close') >= 0)
                    {
                        nav_control_state_handler(elements[i], false);
                    }
                    else if (func.indexOf('do_nav_dn') >= 0 ||
                        func.indexOf('do_nav_last') >= 0)
                    {
                        nav_control_state_handler(elements[i], nav_flags.lastpage ? true : false);
                    }
                    else if (func.indexOf('do_nav_up') >= 0 ||
                             func.indexOf('do_nav_first') >= 0)
                    {
                        nav_control_state_handler(elements[i], nav_flags.firstpage ? true : false);
                    }
                }
            }
        }
    }
}

////

function manage_auth_action_controls(auth_actions)
{
    if (auth_actions)
    {
        for (var qid in auth_actions)
        {
            if (m_map_qid_id[qid])
            {
                var container_ids = m_map_qid_id[qid];

                for (var c = 0; c < container_ids.length; c++)
                {
                    var container = document.getElementById(container_ids[c]);

                    if (container)
                    {
                        var tag_names = ['img', 'input', 'button'];

                        for (var t = 0; t < tag_names.length; t++)
                        {
                            var elements = container.getElementsByTagName(tag_names[t]);

                            if (elements && elements.length)
                            {
                                for (var i = 0; i < elements.length; i++)
                                {
                                    var value = elements[i].getAttribute('onclick');

                                    var func = '';

                                    if (typeof value == 'string')
                                    {
                                        func = value;
                                    }
                                    else if (typeof value == 'function')
                                    {
                                        func = value.toString();
                                    }

                                    if (func && func.indexOf('do_add') >= 0)
                                    {
                                        if (!in_array(auth_actions[qid], '_auth_add_'))
                                        {
                                            elements[i].style.display = 'none';
                                        }
                                    }
                                    else if (func && func.indexOf('do_edit') >= 0)
                                    {
                                        if (!in_array(auth_actions[qid], '_auth_edit_'))
                                        {
                                            elements[i].style.display = 'none';
                                        }
                                    }
                                    else if (func && func.indexOf('do_delete') >= 0)
                                    {
                                        if (!in_array(auth_actions[qid], '_auth_delete_'))
                                        {
                                            elements[i].style.display = 'none';
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

////

function set_container_msg_markup(markup, msg_container_id)
{
    if (typeof msg_container_id != 'string' || !msg_container_id)
    {
        msg_container_id = m_page_msg_id; // TODO: HACK: KLUGE: EXTERN:
    }

    var msg_element = document.getElementById(msg_container_id);

    if (msg_element && typeof markup == 'string')
    {
        msg_element.innerHTML = markup;
    }
}

////

var m_debug_msg_window = null;
var m_debug_msg_window_to_front = false; //true; // DEFAULT: change as appropriate for your needs

function debug_msg(content, error_flag)
{
    if (!m_debug_msg_window || m_debug_msg_window.closed)
    {
        m_debug_msg_window = window.open("", "Messages", "width=700, height=500, scrollbars=1, resizable=1");
    }

    if (m_debug_msg_window)
    {
        var doc = m_debug_msg_window.document;

        doc.open();
        doc.write("<html><head><title>SynApp2 Messages</title></head><body><textarea rows=200 cols=180>");

        if (typeof content == "string" && content.length)
        {
            doc.write(content);
        }
        else
        {
            doc.write("empty");
        }

        doc.write("</textarea></body></html>");
        doc.close();

        if ((error_flag || m_debug_msg_window_to_front) && m_debug_msg_window.focus)
        {
            m_debug_msg_window.focus(); // Mozilla must enable "Raise or lower windows" in advanced settings
        }
    }
}

////

function tr_get_rows(id)
{
    var tr = null;

    var node = document.getElementById(id);

    if (node && node.nodeType == 1)
    {
         var tbody = node.getElementsByTagName("tbody");

         if (tbody && tbody.length)
         {
            tr = tbody[0].getElementsByTagName("tr");
         }
         else
         {
            tr = node.getElementsByTagName("tr");
         }
     }

    return tr;
}

/*
function tr_init_onclick(id, obj)
{
    var tr = tr_get_rows(id);

    if (tr && tr.length)
    {
        for (var i = 0; i < tr.length; i++)
        {
            tr[i].onclick = obj.create_handler_select_row(obj, i);
        }
    }
}
*/
////

// adapted from code posted on 08-23-2002 by RoyW to
// http://codingforums.com/archive/index.php?t-4555.html
//
function process_search_string()
{
//    var srch = unescape(top.location.search.substring(1));
    var srch = unescape(document.location.search.substring(1));
    var pairs = srch.split(/\&/);

    for (var i in pairs)
    {
        var pair = pairs[i].split(/\=/);
        window['g_search_' + pair[0]] = pair[1];
    }
}

process_search_string();

////

function set_input_text_value(id, value)
{
    document.getElementById(id).value = value;
}

function get_input_text_value(id)
{
    return document.getElementById(id).value;
}

////

// cookie functions adapted from code
// posted on http://www.quirksmode.org/js/cookies.html

function set_cookie(name, value, days)
{
    var expires = '';

    if (days)
    {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    }

    var terms = name + "=" + encodeURIComponent(value) + expires + "; path=/";

    document.cookie = terms;
}

function set_session_cookie(name, value)
{
    set_cookie(name, value, 0);
}

function set_synapp2_cookie(name, value)
{
    set_cookie(name, value, 32);
}

function delete_cookie(name)
{
    set_cookie(name, "", -1);
}

function get_cookie(name)
{
    var value = '';

    var nameEQ = name + "=";
    var ca = document.cookie.split(';');

    for (var i = 0; i < ca.length; i++)
    {
        var c = ca[i];

        while (c.charAt(0) == ' ')
        {
            c = c.substring(1, c.length);
        }

        if (c.indexOf(nameEQ) == 0)
        {
            value = decodeURIComponent(c.substring(nameEQ.length, c.length));
            break;
        }
    }

    return value;
}

////

function dumpNodes(node)
{
    var text = "";

    if (node)
    {
        if (node.nodeType == 3) // TEXT_NODE
        {
            text += node.nodeValue;
        }
        else
        {
            if (node.nodeType == 1) // ELEMENT_NODE
            {
                text += node.nodeName + " ";
                text += dumpAttrs(node);
            }

            if (node.hasChildNodes())
            {
                for (var i = 0; i < node.childNodes.length; i++)
                {
                    text += dumpNodes(node.childNodes[i]);
                }
            }
        }
    }

    return text;
}

function dumpAttrs(node)
{
    var text = "";

    if (node && node.attributes && node.attributes.length)
    {
        var attrs = node.attributes;

        for (var i = 0; i < attrs.length; i++)
        {
            text += attrs[i].name + "=" + '"' + attrs[i].value + '" ';
        }
    }

    return text;
}

////
